<img src="https://github.com/JuliaPy/CondaPkg.jl/raw/main/logo.png" alt="CondaPkg.jl logo" style="width: 100px;">

# CondaPkg.jl

[![Project Status: Active – The project has reached a stable, usable state and is being actively developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
[![Test Status](https://github.com/JuliaPy/CondaPkg.jl/actions/workflows/tests.yml/badge.svg)](https://github.com/JuliaPy/CondaPkg.jl/actions/workflows/tests.yml)
[![Codecov](https://codecov.io/gh/JuliaPy/CondaPkg.jl/branch/main/graph/badge.svg?token=1flP5128hZ)](https://codecov.io/gh/JuliaPy/CondaPkg.jl)

Add [Conda](https://docs.conda.io/en/latest/) dependencies to your Julia project.

## Overview

This package is a lot like Pkg from the Julia standard library, except that it is for
managing Conda packages.
- Conda dependencies are defined in `CondaPkg.toml`, which is analogous to `Project.toml`.
- CondaPkg will install these dependencies into a Conda environment specific to the current
  Julia project. Hence dependencies are isolated from other projects or environments.
- Functions like `add`, `rm`, `status` exist to edit the dependencies programmatically.
- Or you can do `pkg> conda add some_package` to edit the dependencies from the Pkg REPL.

## Install

```
pkg> add CondaPkg
```

## Specifying dependencies

### Pkg REPL

The simplest way to specify Conda dependencies is through the Pkg REPL, just like for Julia
dependencies. For example:
```
julia> using CondaPkg
julia> # now press ] to enter the Pkg REPL
pkg> conda status                # see what we have installed
pkg> conda add python perl       # adds conda packages
pkg> conda pip_add build         # adds pip packages
pkg> conda rm perl               # removes conda packages
pkg> conda run python --version  # runs the given command in the conda environment
pkg> conda update                # update conda and pip installed packages
```

For more information do `?` or `?conda` from the Pkg REPL.

**Note:** We recommend against adding Pip packages unless necessary - if there is a
corresponding Conda package then use that. Pip does not handle version conflicts
gracefully, so it is possible to get incompatible versions.

### Functions

These functions are intended to be used interactively when the Pkg REPL is not available
(e.g. if you are in a notebook):

- `status()` shows the Conda dependencies of the current project.
- `add(pkg; version="", channel="")` adds/replaces a dependency or a vector of dependencies.
- `rm(pkg)` removes a dependency or a vector of dependencies.
- `add_channel(channel)` adds a channel.
- `rm_channel(channel)` removes a channel.
- `add_pip(pkg; version="", binary="", editable=false)` adds/replaces a pip dependency.
- `rm_pip(pkg)` removes a pip dependency.

### CondaPkg.toml

Finally, you may edit the `CondaPkg.toml` file directly. Here is a complete example:
```toml
channels = ["anaconda", "conda-forge"]

[deps]
# Conda package names and versions
python = ">=3.5,<4"
pyarrow = "==6.0.0"
perl = ""

[deps.llvmlite]
# Long syntax to specify other fields, such as the channel and build
version = ">=0.38,<0.39"
channel = "numba"
build = "*"

[pip.deps]
# Pip package names and versions
build = "~=0.7.0"
six = ""
some-remote-package = "@ https://example.com/foo.zip"
some-local-package = "@ ./foo.zip"

[pip.deps.pydantic]
# Long syntax to specify other fields
version = "~=2.1"
extras = ["email", "timezone"]
binary = "no"  # or "only"
editable = true

[dev.deps]
# Development dependencies, only installed for packages being developed/tested.
numpy = "~=2.0"
```

## Access the Conda environment

- `envdir()` returns the root directory of the Conda environment.
- `withenv(f)` returns `f()` evaluated in the Conda environment.
- `which(progname)` find the program in the Conda environment.
- `resolve(; force=false)` resolves dependencies. You don't normally need to call this
  because the other API functions will automatically resolve first. Pass `force=true` if
  you change a `CondaPkg.toml` file mid-session.
- `update()` update the conda and pip installed packages.
- `gc()` removes unused caches to save disk space.

### Examples

Assuming one of the dependencies in `CondaPkg.toml` is `python` then the following runs
Python to print its version.
```julia
# Simplest version.
CondaPkg.withenv() do
  run(`python --version`)
end
# Guaranteed not to use Python from outside the Conda environment.
CondaPkg.withenv() do
  python = CondaPkg.which("python")
  run(`$python --version`)
end
# Explicitly specifies the path to the executable (this is package-dependent).
CondaPkg.withenv() do
  python = joinpath(CondaPkg.envdir(), Sys.iswindows() ? "python.exe" : "bin/python")
  run(`$python --version`)
end
```

## Details

### Conda channels

You can specify the channel to install a particular package from, such as with
`pkg> conda add some-channel::some-package`.

You can also specify a top-level list of channels, from which all other packages are
installed, such as with `pkg> conda channel_add some-channel`.

By default, packages are installed from the `conda-forge` channel.

### Pip packages

Direct references such as `pkg> conda pip_add foo@http://example.com/foo.zip` are allowed.
As a special case if the URL starts with `.` then it is interpreted as a path relative
to the directory containing the `CondaPkg.toml` file.

The binary mode specifies whether to only use binary distributions ("only") or to never
use them ("no").

Extras (also known as optional dependencies) can be installed like
`pkg> conda pip_add foo[some-extra,another-extra]`.

### Preferences

You can configure this package with a number of preferences. These can be set either as
[Julia preferences](https://github.com/JuliaPackaging/Preferences.jl) or as environment
variables. This table gives an overview of the preferences, and later sections describe them
in more detail.

| Preference | Environment variable | Description |
| ---------- | -------------------- | ----------- |
| `backend` | `JULIA_CONDAPKG_BACKEND` | One of `MicroMamba`, `Pixi`, `System`, `Current`, `SystemPixi` or `Null` |
| `exe` | `JULIA_CONDAPKG_EXE` | Path to the Conda/Mamba/MicroMamba/Pixi executable. |
| `offline` | `JULIA_CONDAPKG_OFFLINE` | When `true`, work in offline mode. |
| `env` | `JULIA_CONDAPKG_ENV` | Path to the Conda environment to use. |
| `verbosity` | `JULIA_CONDAPKG_VERBOSITY` | One of `-1`, `0`, `1` or `2`. |
| `pip_backend` | `JULIA_CONDAPKG_PIP_BACKEND` | One of `pip` or `uv`. |
| `allowed_channels` | `JULIA_CONDAPKG_ALLOWED_CHANNELS` | List of allowed Conda channels. |
| `channel_priority` | `JULIA_CONDAPKG_CHANNEL_PRIORITY` | One of `strict`, `flexible` (default) or `disabled`. |
| `channel_order` | `JULIA_CONDAPKG_CHANNEL_ORDER` | List specifying channel order, with optional `...` for other channels. |
| `channel_mapping` | `JULIA_CONDAPKG_CHANNEL_MAPPING` | Map of channel names to rename (old->new). |
| `libstdcxx_version` | `JULIA_CONDAPKG_LIBSTDCXX_VERSION` | Either `ignore` or a version specifier. |
| `libstdcxx_ng_version` | `JULIA_CONDAPKG_LIBSTDCXX_NG_VERSION` | Either `ignore` or a version specifier. |
| `openssl_version` | `JULIA_CONDAPKG_OPENSSL_VERSION` | Either `ignore` or a version specifier. |

The easiest way to set these preferences is with the
[`PreferenceTools`](https://github.com/cjdoris/PreferenceTools.jl)
package. For example:
```
julia> using PreferenceTools
julia> # now press ] to enter the Pkg REPL
pkg> preference add CondaPkg backend=System offline=true
```

### Backends

This package has a number of different "backends" which control exactly which implementation
of Conda is used to manage the Conda environments. You can explicitly select a backend
by setting the `backend` preference to one of the following values:
- `MicroMamba`: Uses MicroMamba from the package
  [MicroMamba.jl](https://github.com/JuliaPy/MicroMamba.jl).
- `Pixi`: Uses [Pixi](https://pixi.sh) from
  [pixi_jll](https://github.com/JuliaBinaryWrappers/pixi_jll.jl) to manage the Conda
  environments.
- `System`: Use a pre-installed Conda. If the `exe` preference is set, that is used.
  Otherwise we look for `conda`, `mamba` or `micromamba` in your `PATH`.
- `SystemPixi`: Use a pre-installed [Pixi](https://pixi.sh). If the `exe` preference
  is set, that is used. Otherwise we look for `pixi` in your `PATH`.
- `Current`: Use the currently activated Conda environment instead of creating a new one.
  This backend will only ever install packages, never uninstall. The Conda executable used
  is the same as for the System backend. Similar to the default behaviour of
  [Conda.jl](https://github.com/JuliaPy/Conda.jl).
- `Null`: Don't use CondaPkg to manage dependencies. Use this if you are in a pre-existing
  Conda environment that already satisfies the dependencies of your project. It is up to you
  to ensure any required packages are installed.

The default backend is an implementation detail, but is currently `Pixi` or `MicroMamba`,
depending on your system.

If you set the `exe` preference but not the `backend` preference then the `System` or
`SystemPixi` backend is used.

### Offline mode

You may activate "offline mode" by setting the preference `offline=true`.
This will prevent CondaPkg from attempting to download or
install new packages. In this case, it is up to you to ensure that any required packages are
already available (such as by having previously called `CondaPkg.resolve()`).

### Conda environment path

By default, CondaPkg installs Conda packages into the current project, so that different
projects can have different dependencies. If you wish to centralize the Conda environment,
you can set one of these preferences:
- `env=@<name>` for a named shared environment, stored in `~/.julia/conda_environments/<name>`.
- `env=<some absolute path>` for a shared environment at the given path.
- `backend=Current` to use the currently activated Conda environment.

**Warning:** If you do this, the versions specified in a per-julia-version `CondaPkg.toml`
can become un-synchronized with the packages installed in the shared Conda environment.
In this case, you will have to re-resolve the dependencies using `resolve(force=true)`.
This restriction might be alleviated in future CondaPkg versions.

### Verbosity

You can control the verbosity of any `conda` or `pip` commands executed by setting the
`verbosity` preference to a number:
- `-1` is quiet mode.
- `0` is normal mode (the default).
- `1`, `2`, etc. are verbose modes, useful for debugging.

### Pip Backends

You can control which package manager is used to install pip dependencies by setting the
`pip_backend` preference to one of:
- `pip`
- `uv` (the default).

### Allowed Channels

You can restrict which Conda channels are allowed to be used by setting the `allowed_channels` preference to a list of channel names. For example:
```
pkg> preference add CondaPkg allowed_channels=conda-forge,anaconda
```

This restriction helps ensure reproducibility and security by preventing the use of untrusted channels.

You can instead set it as an environment variable using a space-separated list:
```
julia> ENV["JULIA_CONDAPKG_ALLOWED_CHANNELS"] = "conda-forge anaconda"
```

When this preference is set:
- Any attempt to use a channel not in the allowed list will result in an error.
- This applies to both package-specific channels (e.g. `some-channel::some-package`) and global channels.

If the preference is not set, all channels are allowed.

### Channel Priority and Ordering

You can control how channels are prioritized using the `channel_priority` preference:
- `flexible` (default): Packages from lower-priority channels can satisfy dependencies as long as they are newer than those in higher-priority channels.
- `strict`: Only packages from the highest-priority channel that contains the package will be considered.
- `disabled`: Channel priority is ignored.

You can control the order of channels using the `channel_order` preference. This is a list of channel names that specifies the order in which channels should be considered. For example:
```
pkg> preference add CondaPkg channel_order=conda-forge,anaconda,...,pytorch
```

The special entry `...` indicates where any other channels should go. If not specified, other channels go at the end. So `[foo, bar]` is equivalent to `[foo, bar, ...]`.

You can instead set it as an environment variable using a space-separated list:
```
julia> ENV["JULIA_CONDAPKG_CHANNEL_ORDER"] = "conda-forge anaconda ... pytorch"
```

Note that when using the Pixi backend, `flexible` priority is not supported and will be treated as `strict`.

### Compatibility between Julia and Conda packages

If you use both a Julia package and a Conda package which both use the same underlying
shared library, there can be compatibility issues if they are at different versions.

To alleviate this, CondaPkg handles some packages specially. For the following Conda
packages, if the version is set to `<=julia`, then a version of that package compatible
with the corresponding Julia package will be installed.
- `libstdcxx`: Compatible with libstdc++ in `Base`.
- `libstdcxx-ng`: Compatible with libstdc++ in `Base`.
- `openssl`: Compatible with `OpenSSL_jll` (if installed).

You can override this behaviour with the `libstdcxx_version`, `libstdcxx_ng_version` and
`openssl_version` preferences. These can be set to one of:
- A (non-empty) specific Conda version specifier.
- `ignore` to ignore the compatibility constraint entirely.
- Unset or the empty string for the default behaviour.

### Channel Mapping

You can map channel names to new names using the `channel_mapping` preference. This is useful when working with corporate proxies or mirrors. The mapping can be specified in several formats:

- As a dictionary: `channel_mapping=Dict("old1" => "new1", "old2" => "new2")`
- As a space-separated string: `channel_mapping="old1->new1 old2->new2"`
- As a list of strings: `channel_mapping=["old1->new1", "old2->new2"]`

For example, to map conda-forge to a corporate mirror:
```
pkg> preference add CondaPkg channel_mapping=conda-forge->corporate-conda-mirror
```

### Dev dependencies

The `[dev]` section in a CondaPkg.toml is parsed if it is in a package which is
currently being developed (in the sense of `Pkg.develop`) or tested. It can contain
`deps`, `channels` and `pip_deps` that are only required while developing or testing
the package and will not be installed for ordinary users.

You can pass `dev=true` to the `add` and `rm` functions to modify the `dev` section.

Similarly you can pass `--dev` to the `add` and `rm` commands in the Pkg REPL.

Dev dependencies are shown by `status()` in separate sections.

## Frequently Asked Questions

### Can I get my package to use a specific Conda environment?

No. The location of the Conda environment is configured purely by the user. Letting packages
specify this configuration is not composable - if two packages want to set the location of
the environment, then they will be in conflict.

### Can I make the Pkg REPL command work without `using CondaPkg` first?

Yes, you can add the following to your [startup
file](https://docs.julialang.org/en/v1/manual/command-line-interface/#Startup-file)
(`~/.julia/config/startup.jl`):

```julia
if isinteractive()
    try
       using CondaPkg
    catch
       @warn "CondaPkg not available"
    end
end
```

### Can I install a package from a URL or file?

Yes, using the "direct reference" `@` version syntax. For example in PKG REPL mode
```
pkg> pip_add some-package@https://example.com/the/url
```
or using the API
```julia
CondaPkg.add_pip("some-package", version="@https://example.com/the/url")
```
or in `CondaPkg.toml`
```toml
[pip.deps]
"some-package" = "@https://example.com/the/url"
```

module CondaPkg

if isdefined(Base, :Experimental) &&
   isdefined(Base.Experimental, Symbol("@compiler_options"))
    # Without this, resolve() takes a couple of seconds, with, it takes 0.1 seconds.
    # Maybe with better structured code or precompilation it's not necessary.
    # Note: compile=min makes --code-coverage not work
    @eval Base.Experimental.@compiler_options optimize = 0 infer = false #compile=min
end

using Base: @kwdef
using JSON3: JSON3
using Pidfile: Pidfile
using Preferences: @load_preference
using Pkg: Pkg
using Scratch: @get_scratch!
using TOML: TOML

# avoid loading backends which are definitely not used
if @load_preference("backend", "MicroMamba") == "MicroMamba"
    using MicroMamba: MicroMamba
end
if @load_preference("backend", "Pixi") == "Pixi"
    using pixi_jll: pixi_jll
end

let toml = TOML.parsefile(joinpath(@__DIR__, "..", "Project.toml"))
    @eval const UUID = Base.UUID($(toml["uuid"]))
    @eval const PKGID = Base.PkgId(UUID, "CondaPkg")
    @eval const VERSION = Base.VersionNumber($(toml["version"]))
end

@kwdef mutable struct State
    # backend
    backend::Symbol = :NotSet
    condaexe::String = ""
    pixiexe::String = ""
    # resolve
    resolved::Bool = false
    load_path::Vector{String} = String[]
    meta_dir::String = ""
    conda_env::String = ""
    shared::Bool = false
    frozen::Bool = false
    # testing
    testing::Bool = false
    test_preferences::Dict{String,Any} = Dict{String,Any}()
end

const STATE = State()

function getpref(::Type{T}, prefname, envname, default = nothing) where {T}
    if STATE.testing
        ans = get(STATE.test_preferences, prefname, nothing)
        ans === nothing || return checkpref(T, ans)::T
        return default
    end
    ans = @load_preference(prefname, nothing)
    ans === nothing || return checkpref(T, ans)::T
    ans = get(ENV, envname, "")
    isempty(ans) || return checkpref(T, ans)::T
    return default
end

checkpref(::Type{T}, x) where {T} = convert(T, x)
checkpref(::Type{String}, x::AbstractString) = convert(String, x)
checkpref(::Type{T}, x::AbstractString) where {T} = parse(T, x)
checkpref(::Type{Bool}, x::AbstractString) =
    x in ("yes", "true") ? true :
    x in ("no", "false") ? false : error("expecting true or false, got $(repr(x))")
checkpref(::Type{Vector{String}}, x::AbstractString) = collect(String, split(x))
checkpref(::Type{Dict{String,String}}, x::AbstractString) =
    checkpref(Dict{String,String}, split(x))
checkpref(::Type{Pair{String,String}}, x::AbstractString) =
    let (x1, x2) = split(x, "->", limit = 2)
        Pair{String,String}(x1, x2)
    end
checkpref(::Type{Dict{String,String}}, x::AbstractVector) =
    Dict{String,String}(checkpref(Pair{String,String}, p) for p in x)

# Specific preference functions
getpref_backend() = getpref(String, "backend", "JULIA_CONDAPKG_BACKEND", "")
getpref_exe() = getpref(String, "exe", "JULIA_CONDAPKG_EXE", "")
getpref_env() = getpref(String, "env", "JULIA_CONDAPKG_ENV", "")
getpref_libstdcxx_ng_version() =
    getpref(String, "libstdcxx_ng_version", "JULIA_CONDAPKG_LIBSTDCXX_NG_VERSION", "")
getpref_libstdcxx_version() =
    getpref(String, "libstdcxx_version", "JULIA_CONDAPKG_LIBSTDCXX_VERSION", "")
getpref_openssl_version() =
    getpref(String, "openssl_version", "JULIA_CONDAPKG_OPENSSL_VERSION", "")
getpref_verbosity() = getpref(Int, "verbosity", "JULIA_CONDAPKG_VERBOSITY", 0)
getpref_offline() = getpref(Bool, "offline", "JULIA_CONDAPKG_OFFLINE", false)

function getpref_channel_priority()
    p = getpref(String, "channel_priority", "JULIA_CONDAPKG_CHANNEL_PRIORITY", "flexible")
    if p in ("strict", "flexible", "disabled")
        return p
    else
        error("channel_priority must be strict, flexible or disabled, got $p")
    end
end

function getpref_channel_order()
    order =
        getpref(Vector{String}, "channel_order", "JULIA_CONDAPKG_CHANNEL_ORDER", String[])
    String[c == "..." ? c : validate_channel(c) for c in order]
end

function getpref_pip_backend()
    b = getpref(String, "pip_backend", "JULIA_CONDAPKG_PIP_BACKEND", "uv")
    if b == "pip"
        :pip
    elseif b == "uv"
        :uv
    else
        error("pip_backend must be pip or uv, got $b")
    end
end

function getpref_allowed_channels()
    channels = getpref(
        Vector{String},
        "allowed_channels",
        "JULIA_CONDAPKG_ALLOWED_CHANNELS",
        nothing,
    )
    if channels === nothing
        nothing
    else
        Set{String}(validate_channel(c) for c in channels)
    end
end

function getpref_channel_mapping()
    mapping = getpref(
        Dict{String,String},
        "channel_mapping",
        "JULIA_CONDAPKG_CHANNEL_MAPPING",
        Dict{String,String}(),
    )

    # Validate all channel names
    validated = Dict{String,String}()
    for (old, new) in mapping
        old_validated = validate_channel(old)
        new_validated = validate_channel(new)
        validated[old_validated] = new_validated
    end

    validated
end

include("backend.jl")
include("spec.jl")
include("meta.jl")
include("resolve.jl")
include("env.jl")
include("deps.jl")

include("PkgREPL.jl")

end # module

@testitem "resolve (empty)" begin
    include("setup.jl")
    @test CondaPkg.resolve() === nothing
    @test occursin("(empty)", status())
end

@testitem "Null backend" begin
    include("setup.jl")
    if isnull
        @test CondaPkg.backend() == :Null
        @test CondaPkg.activate!(copy(ENV)) == ENV
        @test occursin("Null", status())
        @test_throws ErrorException CondaPkg.envdir()
    else
        @test true
    end
end

@testitem "add/remove channel" begin
    include("setup.jl")
    @test !occursin("conda-forge", status())
    CondaPkg.add_channel("conda-forge")
    @test occursin("conda-forge", status())
    CondaPkg.rm_channel("conda-forge")
    @test !occursin("conda-forge", status())
end

@testitem "install python" begin
    include("setup.jl")
    @test !occursin("python", status())
    CondaPkg.add("python", version = "==3.10.2")
    isnull || CondaPkg.withenv() do
        pythonpath =
            joinpath(CondaPkg.envdir(), Sys.iswindows() ? "python.exe" : "bin/python")
        @test isfile(pythonpath)
    end
    @test occursin("python", status())
end

@testitem "install dev dependencies" begin
    include("setup.jl")
    # test that the dev dependencies in CondaPkg.toml get installed
    CondaPkg.withenv() do
        isnull || run(
            `python -c "import tomli, requests; assert requests.__version__ == '2.32.5'; assert tomli.__version__ == '2.2.1'"`,
        )
    end
    @test true
end

@testitem "install/remove python package" begin
    include("setup.jl")
    CondaPkg.add("python", version = "==3.10.2")
    # verify package isn't already installed
    @test !occursin("six", status())
    CondaPkg.withenv() do
        isnull || @test_throws Exception run(`python -c "import six"`)
    end

    # install package
    CondaPkg.add("six", version = "==1.16.0")
    @test occursin("six", status())
    @test occursin("(==1.16.0)", status())
    CondaPkg.withenv() do
        isnull || run(`python -c "import six"`)
    end
    @test occursin("v1.16.0", status()) == !isnull

    # remove package
    CondaPkg.rm("six")
    @test !occursin("six", status())
    CondaPkg.withenv() do
        isnull || @test_throws Exception run(`python -c "import six"`)
    end
end

@testitem "install/remove multiple python packages" begin
    include("setup.jl")
    CondaPkg.add("python", version = "==3.10.2")
    # verify package isn't already installed
    @test !occursin("jsonlines ", status())
    @test !occursin("cowpy", status())
    CondaPkg.withenv() do
        isnull || @test_throws Exception run(`python -c "import jsonlines"`)
        isnull || @test_throws Exception run(`python -c "import cowpy"`)
    end

    # install multiple packages
    CondaPkg.add(["jsonlines", "cowpy"])
    @test occursin("jsonlines", status())
    @test occursin("cowpy", status())

    # remove multiple packages
    CondaPkg.rm(["jsonlines", "cowpy"])
    @test !occursin("jsonlines ", status())
    @test !occursin("cowpy", status())
    CondaPkg.withenv() do
        isnull || @test_throws Exception run(`python -c "import jsonlines"`)
        isnull || @test_throws Exception run(`python -c "import cowpy"`)
    end
end

@testitem "pip install/remove python package" begin
    @testset "using $kind" for kind in ["pip", "uv"]
        include("setup.jl")
        CondaPkg.add("python", version = "==3.10.2")
        if kind == "uv"
            # TODO: there is an explicit flag for this now
            CondaPkg.add("uv")
        end
        # verify package isn't already installed
        @test !occursin("six", status())
        CondaPkg.withenv() do
            isnull || @test_throws Exception run(`python -c "import six"`)
        end

        # install package
        CondaPkg.add_pip("six", version = "==1.16.0")
        @test occursin("six", status())
        @test occursin("(==1.16.0)", status())
        CondaPkg.withenv() do
            isnull || run(`python -c "import six"`)
        end
        @test occursin("v1.16.0", status()) == !isnull

        # remove package
        CondaPkg.rm_pip("six")
        @test !occursin("six", status())
        CondaPkg.withenv() do
            isnull || @test_throws Exception run(`python -c "import six"`)
        end
    end
end

@testitem "pip install/remove python package with extras" begin
    include("setup.jl")
    CondaPkg.add("python", version = "==3.10.2")

    # verify package isn't already installed
    @test !occursin("pydantic", status())
    CondaPkg.withenv() do
        isnull || @test_throws Exception run(`python -c "import pydantic"`)
    end

    # install package without extras
    CondaPkg.add_pip("pydantic", version = "==2.9.2")
    @test occursin("pydantic", status())
    @test occursin("(==2.9.2)", status())
    CondaPkg.withenv() do
        isnull || run(`python -c "import pydantic"`)
        # fails on Windows sometimes - not sure why
        # probably email-validator is still installed from an earlier test
        isnull ||
            Sys.iswindows() ||
            @test_throws Exception run(`python -c "import email_validator"`)
    end
    @test occursin("v2.9.2", status()) == !isnull

    # install package with extras
    CondaPkg.add_pip("pydantic", version = "==2.9.2", extras = ["email"])
    @test occursin("pydantic", status())
    @test occursin("(==2.9.2, [email])", status())
    CondaPkg.withenv() do
        isnull || run(`python -c "import pydantic"`)
        isnull || run(`python -c "import email_validator"`)
    end
    @test occursin("v2.9.2", status()) == !isnull

    # remove package
    CondaPkg.rm_pip("pydantic")
    @test !occursin("pydantic", status())
    CondaPkg.withenv() do
        isnull || @test_throws Exception run(`python -c "import pydantic"`)
    end
end

@testitem "pip install/remove local python package" begin
    @testset "file $file $kwargs" for (file, kwargs) in [
        ("example-python-package", NamedTuple()),
        ("example_python_package-1.0.0-py3-none-any.whl", NamedTuple()),
        ("example_python_package-1.0.0.tar.gz", NamedTuple()),
        ("example-python-package", (editable = true,)),
    ]
        include("setup.jl")
        CondaPkg.add("python", version = "==3.10.2")
        # verify package isn't already installed
        @test !occursin("example-python-package", status())
        CondaPkg.withenv() do
            isnull ||
                @test_throws Exception run(`python -c "import example_python_package"`)
        end

        # install package
        path = "./test/data/$file"
        fullpath = abspath(dirname(CondaPkg.cur_deps_file()), path)
        @assert ispath(fullpath)
        editable = get(kwargs, :editable, false)
        CondaPkg.add_pip("example-python-package", version = "@$path"; kwargs...)
        @test occursin("example-python-package", status())
        if isempty(kwargs)
            @test occursin("(@$path)", status())
        else
            @test occursin("(@$path,", status())
        end
        @test occursin("editable", status()) == editable
        CondaPkg.withenv() do
            isnull || run(`python -c "import example_python_package"`)
        end
        @test occursin("v1.0.0", status()) == !isnull

        # check editability
        if editable && !isnull
            @assert isdir(fullpath)
            added_path = joinpath(fullpath, "src", "example_python_package", "added.py")
            # check a particular submodule does not exist
            rm(added_path; force = true)
            CondaPkg.withenv() do
                @test_throws Exception run(
                    `python -c "from example_python_package.added import foo"`,
                )
            end
            # now add it and check we can import it
            write(added_path, "foo = 12")
            CondaPkg.withenv() do
                run(`python -c "from example_python_package.added import foo"`)
            end
            # remove it again
            rm(added_path; force = true)
            CondaPkg.withenv() do
                @test_throws Exception run(
                    `python -c "from example_python_package.added import foo"`,
                )
            end
        end

        # remove package
        CondaPkg.rm_pip("example-python-package")
        @test !occursin("example-python-package", status())
        CondaPkg.withenv() do
            isnull ||
                @test_throws Exception run(`python -c "import example_python_package"`)
        end
    end
end

@testitem "install/remove executable package" begin
    include("setup.jl")
    if !isnull
        CondaPkg.add("uv", resolve = false)
        CondaPkg.resolve(force = true)
        exe_path = CondaPkg.which("uv")
        @test exe_path !== nothing
        @test isfile(exe_path)
        CondaPkg.rm("uv", resolve = false)
        CondaPkg.resolve(force = true)
        @test !isfile(exe_path)
    end
end

@testitem "install/remove libstdcxx-ng" begin
    include("setup.jl")
    CondaPkg.add("libstdcxx-ng", version = "<=julia", resolve = false)
    CondaPkg.resolve(force = true)
    CondaPkg.rm("libstdcxx-ng", resolve = false)
    CondaPkg.resolve(force = true)
    @test true
end

@testitem "install/remove libstdcxx" begin
    include("setup.jl")
    CondaPkg.add("libstdcxx", version = "<=julia", resolve = false)
    CondaPkg.resolve(force = true)
    CondaPkg.rm("libstdcxx", resolve = false)
    CondaPkg.resolve(force = true)
    @test true
end

@testitem "install/remove openssl" begin
    include("setup.jl")
    CondaPkg.add("openssl", version = "<=julia", resolve = false)
    CondaPkg.resolve(force = true)
    CondaPkg.rm("openssl", resolve = false)
    CondaPkg.resolve(force = true)
    @test true
end

@testitem "install cpython" begin
    @testset "$version" for version in ["3.12.*", "3.13.*"]
        include("setup.jl")
        CondaPkg.add("python", version = version, build = "**cpython**")
        @test occursin("python", status())
        @test occursin("($version, build=**cpython**)", status())
    end
end

@testitem "install non-existent package" begin
    include("setup.jl")

    if !isnull
        # First add a package to ensure we are in a resolved state
        CondaPkg.add("python", version = "==3.10.2")

        # Verify clean state
        @test !occursin("Not Resolved", status())
        @test !occursin("nonexistentpackage123xyz", status())
        @test occursin("python", status())

        # Try to add non-existent package and verify it throws
        @test_throws Exception CondaPkg.add("nonexistentpackage123xyz")

        # Verify that resolving failed
        @test !CondaPkg.STATE.resolved

        # is_resolved() re-checks that the old deps are still valid (except Pixi)
        @test CondaPkg.is_resolved() == !ispixi

        # Verify the deps file was reverted
        @test !occursin("nonexistentpackage123xyz", status())
        @test occursin("python", status())
    end
end

@testitem "external conda env" begin
    include("setup.jl")
    dn = string(tempname(), backend, Sys.KERNEL, VERSION)
    if !isnull && !ispixi
        CondaPkg.STATE.test_preferences["env"] = dn
        # create empty env
        CondaPkg.resolve()
        @test !occursin("ca-certificates", status())
        # add a package to specs and install it
        CondaPkg.add("ca-certificates"; interactive = true, force = true)  # force: spurious windows failures
        @test occursin("ca-certificates", status())
        CondaPkg.withenv() do
            @test isfile(
                CondaPkg.envdir(Sys.iswindows() ? "Library" : "", "ssl", "cacert.pem"),
            )
        end
        # remove a package from specs, it must remain installed because we use a shared centralized env
        CondaPkg.rm("ca-certificates"; interactive = true, force = true)
        @test !occursin("ca-certificates", status())  # removed from specs ...
        CondaPkg.withenv() do  # ... but still installed (shared env might be used by specs from alternate julia versions)
            @test isfile(
                CondaPkg.envdir(Sys.iswindows() ? "Library" : "", "ssl", "cacert.pem"),
            )
        end
    end
end

@testitem "shared env" begin
    include("setup.jl")
    if !isnull && !ispixi
        CondaPkg.STATE.test_preferences["env"] = "@my_env"
        CondaPkg.add("python"; force = true)
        @test CondaPkg.envdir() ==
              joinpath(Base.DEPOT_PATH[1], "conda_environments", "my_env")
        @test isfile(CondaPkg.envdir(Sys.iswindows() ? "python.exe" : "bin/python"))
    end
    if !isnull && !ispixi
        CondaPkg.STATE.test_preferences["env"] = "@/some/absolute/path"
        @test_throws ErrorException CondaPkg.add("python"; force = true)
    end
end

@testitem "update" begin
    include("setup.jl")
    CondaPkg.update()
    @test CondaPkg.is_resolved()
end

@testitem "gc" begin
    include("setup.jl")
    testgc && CondaPkg.gc()
    @test true
end

@testitem "validation" begin
    include("setup.jl")
    @test_throws Exception CondaPkg.add("!invalid!package!")
    @test_throws Exception CondaPkg.add_pip("!invalid!package!")
    @test_throws Exception CondaPkg.add("valid-package", version = "*invalid*version*")
    @test_throws Exception CondaPkg.add_pip("valid-package", version = "*invalid*version*")
    @test_throws Exception CondaPkg.add_channel("")
    @test !occursin("valid", status())
end

using TestItemRunner

# NOTE: use CI=true env var to avoid micromamba
# flooding the terminal with progress bar characters

if get(ENV, "CI", "false") == "false"
    @info "local tests"
    # start with a clean state when running local tests
    delete!(ENV, "MAMBA_ROOT_PREFIX")
    delete!(ENV, "JULIA_CONDAPKG_VERBOSITY")
    delete!(ENV, "JULIA_CONDAPKG_BACKEND")
    delete!(ENV, "JULIA_CONDAPKG_OFFLINE")
    delete!(ENV, "JULIA_CONDAPKG_EXE")
    delete!(ENV, "JULIA_CONDAPKG_ENV")
end

# if you run tests in a conda environment, these env vars cause the aqua persistent tasks test to error
if haskey(ENV, "CONDA_PREFIX")
    delete!(ENV, "SSL_CERT_FILE")
    delete!(ENV, "SSL_CERT_DIR")
end

@run_package_tests

@testitem "PkgSpec" begin
    include("setup.jl")
    @test_throws Exception CondaPkg.PkgSpec("")
    @test_throws Exception CondaPkg.PkgSpec("foo!")
    @test_throws Exception CondaPkg.PkgSpec("foo", version = "foo")
    spec = CondaPkg.PkgSpec(
        "  F...OO_-0  ",
        version = "  =1.2.3  ",
        channel = "  SOME_chaNNEL  ",
    )
    @test spec.name == "f...oo_-0"
    @test spec.version == "=1.2.3"
    @test spec.channel == "SOME_chaNNEL"
end

@testitem "ChannelSpec" begin
    include("setup.jl")
    @test_throws Exception CondaPkg.ChannelSpec("")
    spec = CondaPkg.ChannelSpec("  SOME_chaNNEL  ")
    @test spec.name == "SOME_chaNNEL"
end

@testitem "PipPkgSpec" begin
    include("setup.jl")
    @test_throws Exception CondaPkg.PipPkgSpec("")
    @test_throws Exception CondaPkg.PipPkgSpec("foo!")
    @test_throws Exception CondaPkg.PipPkgSpec("foo", version = "1.2")
    @test_throws Exception CondaPkg.PipPkgSpec("foo", editable = true)
    @test_throws Exception CondaPkg.PipPkgSpec("foo", version = "1.2", editable = true)
    spec = CondaPkg.PipPkgSpec("  F...OO_-0  ", version = "  @./SOME/Path  ")
    @test spec.name == "f-oo-0"
    @test spec.version == "@./SOME/Path"
end

@testitem "meta IO" begin
    include("setup.jl")
    specs = Any[
        CondaPkg.PkgSpec("foo", version = "=1.2.3", channel = "bar"),
        CondaPkg.ChannelSpec("fooo"),
        CondaPkg.PipPkgSpec("foooo", version = "==2.3.4"),
        CondaPkg.PipPkgSpec("bar", version = "@ /abs/path/somewhere", editable = true),
        CondaPkg.PipPkgSpec("baz", version = "@ ./rel/path/somewhere", editable = true)
    ]
    for spec in specs
        io = IOBuffer()
        CondaPkg.write_meta(io, spec)
        seekstart(io)
        spec2 = CondaPkg.read_meta(io, typeof(spec))
        @test spec == spec2
        for k in propertynames(spec)
            @test getproperty(spec, k) == getproperty(spec2, k)
        end
    end
end

@testitem "abspathurl" begin
    include("setup.jl")
    @test startswith(CondaPkg.abspathurl("foo"), "file://")
    @test endswith(CondaPkg.abspathurl("foo"), "/foo")
    if Sys.iswindows()
        @test CondaPkg.abspathurl("D:\\Foo\\bar.TXT") == "file:///D:/Foo/bar.TXT"
    else
        @test CondaPkg.abspathurl("/Foo/bar.TXT") == "file:///Foo/bar.TXT"
    end
end

@testitem "pathfromurl" begin
    include("setup.jl")
    if Sys.iswindows()
        @test CondaPkg.pathfromurl("file:///C:/foo/bar.txt") == "C:\\foo\\bar.txt"
    else
        @test CondaPkg.pathfromurl("file:///foo/bar.txt") == "/foo/bar.txt"
    end
end

@testitem "pixispec" begin
    include("setup.jl")
    @testset "$(case.args)" for case in [
        (args = (), expected = "*"),
        (args = (version = "=1.2.3",), expected = "=1.2.3"),
        (
            args = (extras = ["bar", "baz"],),
            expected = Dict("extras" => ["bar", "baz"], "version" => "*"),
        ),
        (
            args = (version = "@git+https://github.com/example/example.git",),
            expected = Dict("git" => "https://github.com/example/example.git"),
        ),
        (
            args = (version = "@git+https://github.com/example/example.git@rev",),
            expected = Dict(
                "git" => "https://github.com/example/example.git",
                "rev" => "rev",
            ),
        ),
        (
            args = (version = "@git+https://github.com/example/example.git@tag#rev",),
            expected = Dict(
                "git" => "https://github.com/example/example.git",
                "rev" => "rev",
            ),
        ),
        (
            args = (version = Sys.iswindows() ? "@file:///C:/foo" : "@file:///foo",),
            expected = Dict("path" => Sys.iswindows() ? "C:\\foo" : "/foo"),
        ),
    ]
        @test CondaPkg.pixispec(CondaPkg.PipPkgSpec("foo"; case.args...)) == case.expected
    end
end

@testitem "_resolve_merge_versions" begin
    include("setup.jl")
    @testset "$(case.v1) $(case.v2)" for case in [
        (v1 = "1.2.3", v2 = "1.2.3", expected = "1.2.3, 1.2.3"),
        (v1 = "1.2.3", v2 = "1.2.4", expected = "1.2.3, 1.2.4"),
        (v1 = "1.2.3", v2 = ">=1.2,<2", expected = "1.2.3, >=1.2,<2"),
        (v1 = ">=1.2,<2", v2 = ">=2.1,<3", expected = ">=1.2,<2, >=2.1,<3"),
        (v1 = "1|2", v2 = "2|3", expected = "1, 2 | 1, 3 | 2, 2 | 2, 3"),
    ]
        @test CondaPkg._resolve_merge_versions(case.v1, case.v2) == case.expected
    end
end

@testitem "_compatible_libstdcxx_ng_version" begin
    include("setup.jl")
    @testset "$new_bound" for new_bound in [nothing, "", "foo"]
        CondaPkg.STATE.test_preferences["libstdcxx_ng_version"] = new_bound
        bound = CondaPkg._compatible_libstdcxx_ng_version()
        if new_bound === nothing || new_bound == ""
            if Sys.islinux()
                if bound !== nothing
                    @test bound isa String
                    @test startswith(bound, ">=")
                end
            else
                @test bound === nothing
            end
        else
            @test bound == new_bound
        end
    end
end

@testitem "_compatible_libstdcxx_version" begin
    include("setup.jl")
    @testset "$new_bound" for new_bound in [nothing, "", "foo"]
        CondaPkg.STATE.test_preferences["libstdcxx_version"] = new_bound
        bound = CondaPkg._compatible_libstdcxx_version()
        if new_bound === nothing || new_bound == ""
            if Sys.islinux()
                if bound !== nothing
                    @test bound isa String
                    @test startswith(bound, ">=")
                end
            else
                @test bound === nothing
            end
        else
            @test bound == new_bound
        end
    end
end

@testitem "_compatible_openssl_version" begin
    include("setup.jl")
    @testset "$new_bound" for new_bound in [nothing, "", "foo"]
        CondaPkg.STATE.test_preferences["openssl_version"] = new_bound
        bound = CondaPkg._compatible_openssl_version()
        if new_bound === nothing || new_bound == ""
            if bound !== nothing
                @test bound isa String
                @test startswith(bound, ">=")
            end
        else
            @test bound == new_bound
        end
    end
end

@testitem "checkpref" begin
    include("setup.jl")

    @testset "$(case.type) conversion" for case in [
        # String conversions
        (type = String, input = "hello", expected = "hello"),

        # Int conversions
        (type = Int, input = "42", expected = 42),
        (type = Int, input = 42, expected = 42),
        (type = Int, input = 42.0, expected = 42),

        # Bool conversions
        (type = Bool, input = "yes", expected = true),
        (type = Bool, input = "true", expected = true),
        (type = Bool, input = "no", expected = false),
        (type = Bool, input = "false", expected = false),
        (type = Bool, input = true, expected = true),
        (type = Bool, input = false, expected = false),

        # Vector{String} conversions
        (type = Vector{String}, input = "", expected = String[]),
        (type = Vector{String}, input = "a b c", expected = ["a", "b", "c"]),
        (type = Vector{String}, input = ["a", "b", "c"], expected = ["a", "b", "c"]),

        # Dict{String,String} conversions
        (
            type = Dict{String,String},
            input = Dict("old" => "new", "foo" => "bar"),
            expected = Dict("old" => "new", "foo" => "bar"),
        ),
        (type = Dict{String,String}, input = "", expected = Dict{String,String}()),
        (type = Dict{String,String}, input = "old->new", expected = Dict("old" => "new")),
        (
            type = Dict{String,String},
            input = "old->new foo->bar",
            expected = Dict("old" => "new", "foo" => "bar"),
        ),
        (
            type = Dict{String,String},
            input = "  old->new   foo->bar  ",
            expected = Dict("old" => "new", "foo" => "bar"),
        ),
        (type = Dict{String,String}, input = String[], expected = Dict{String,String}()),
        (type = Dict{String,String}, input = ["old->new"], expected = Dict("old" => "new")),
        (
            type = Dict{String,String},
            input = ["old->new", "foo->bar"],
            expected = Dict("old" => "new", "foo" => "bar"),
        ),
    ]
        result = CondaPkg.checkpref(case.type, case.input)
        @test result isa case.type
        @test result == case.expected
    end

    @testset "$(case.type) error" for case in [
        (type = String, input = 42),
        (type = String, input = :symbol),
        (type = Bool, input = "invalid"),
        (type = Int, input = "not a number"),
        (type = Vector{String}, input = Any["a", :b, 42]),
    ]
        @test_throws Exception CondaPkg.checkpref(case.type, case.input)
    end
end

@testitem "_resolve_check_allowed_channels" begin
    include("setup.jl")

    # Test no allowed channels set
    packages =
        Dict("foo" => Dict("test.toml" => CondaPkg.PkgSpec("foo", channel = "bad-channel")))
    channels = [CondaPkg.ChannelSpec("conda-forge")]
    @test true ===
          CondaPkg._resolve_check_allowed_channels(devnull, packages, channels, nothing)

    # Test package with disallowed channel
    allowed = Set(["conda-forge"])
    packages =
        Dict("foo" => Dict("test.toml" => CondaPkg.PkgSpec("foo", channel = "bad-channel")))
    channels = [CondaPkg.ChannelSpec("conda-forge")]
    @test_throws ErrorException(
        "Package 'foo' in test.toml requires channel 'bad-channel' which is not in allowed channels list",
    ) CondaPkg._resolve_check_allowed_channels(devnull, packages, channels, allowed)

    # Test global channel not allowed
    allowed = Set(["conda-forge"])
    packages = Dict("foo" => Dict("test.toml" => CondaPkg.PkgSpec("foo")))
    channels = [CondaPkg.ChannelSpec("bad-channel")]
    @test_throws ErrorException(
        "The following channels are not in the allowed list: bad-channel",
    ) CondaPkg._resolve_check_allowed_channels(devnull, packages, channels, allowed)

    # Test multiple disallowed global channels
    allowed = Set(["conda-forge"])
    packages = Dict("foo" => Dict("test.toml" => CondaPkg.PkgSpec("foo")))
    channels = [CondaPkg.ChannelSpec("bad1"), CondaPkg.ChannelSpec("bad2")]
    @test_throws ErrorException(
        "The following channels are not in the allowed list: bad1, bad2",
    ) CondaPkg._resolve_check_allowed_channels(devnull, packages, channels, allowed)

    # Test multiple allowed channels
    allowed = Set(["conda-forge", "anaconda"])
    packages = Dict(
        "foo" => Dict("test.toml" => CondaPkg.PkgSpec("foo", channel = "conda-forge")),
        "bar" => Dict("test.toml" => CondaPkg.PkgSpec("bar", channel = "anaconda")),
    )
    channels = [CondaPkg.ChannelSpec("conda-forge"), CondaPkg.ChannelSpec("anaconda")]
    @test true ===
          CondaPkg._resolve_check_allowed_channels(devnull, packages, channels, allowed)
end

@testitem "_resolve_order_channels!" begin
    include("setup.jl")

    # Test cases for channel ordering
    cases = [
        # Basic ordering: empty order uses defaults
        (channels = ["b", "a", "c"], order = String[], expected = ["a", "b", "c"]),

        # Basic ordering: explicit complete order
        (channels = ["b", "a", "c"], order = ["c", "a", "b"], expected = ["c", "a", "b"]),

        # Basic ordering: partial order
        (channels = ["b", "a", "c"], order = ["c"], expected = ["c", "a", "b"]),
        (channels = ["b", "a", "c"], order = ["b", "c"], expected = ["b", "c", "a"]),

        # Ellipsis handling: in middle
        (
            channels = ["b", "a", "c", "d"],
            order = ["c", "...", "a"],
            expected = ["c", "b", "d", "a"],
        ),

        # Ellipsis handling: at start
        (
            channels = ["b", "a", "c", "d"],
            order = ["...", "a", "b"],
            expected = ["c", "d", "a", "b"],
        ),

        # Ellipsis handling: at end
        (
            channels = ["b", "a", "c", "d"],
            order = ["d", "b", "..."],
            expected = ["d", "b", "a", "c"],
        ),

        # Special channels: conda-forge prioritized
        (
            channels = ["b", "conda-forge", "a"],
            order = String[],
            expected = ["conda-forge", "a", "b"],
        ),

        # Special channels: all special channels present
        (
            channels = ["b", "conda-forge", "anaconda", "pkgs/main", "a"],
            order = String[],
            expected = ["conda-forge", "anaconda", "pkgs/main", "a", "b"],
        ),

        # Special channels: override with explicit order
        (
            channels = ["conda-forge", "a", "b"],
            order = ["...", "b", "conda-forge"],
            expected = ["a", "b", "conda-forge"],
        ),

        # Special channels: override with explicit order and all special channels present
        (
            channels = ["b", "conda-forge", "a", "pkgs/main", "anaconda"],
            order = ["...", "b", "conda-forge"],
            expected = ["anaconda", "pkgs/main", "a", "b", "conda-forge"],
        ),

        # Deduplication: duplicate channels removed
        (
            channels = ["a", "a", "b", "b", "c"],
            order = String[],
            expected = ["a", "b", "c"],
        ),

        # Deduplication: duplicate order entries ignored
        (
            channels = ["a", "b", "c"],
            order = ["a", "a", "b", "b"],
            expected = ["a", "b", "c"],
        ),

        # Missing channels: order entries that don't exist ignored
        (channels = ["a", "b"], order = ["c", "a", "d", "b"], expected = ["a", "b"]),
    ]

    @testset "$(case.channels) $(case.order)" for case in cases
        # Construct channel objects from strings
        channels = [CondaPkg.ChannelSpec(name) for name in case.channels]

        # Apply ordering in-place
        CondaPkg._resolve_order_channels!(channels, case.order)

        # Check result
        @test [c.name for c in channels] == case.expected
    end
end

@testitem "_resolve_map_channels!" begin
    include("setup.jl")

    # Test empty mapping does nothing
    channels = [CondaPkg.ChannelSpec("conda-forge")]
    packages = Dict("foo" => Dict("test.toml" => CondaPkg.PkgSpec("foo")))
    mapping = Dict{String,String}()
    CondaPkg._resolve_map_channels!(channels, packages, mapping)
    @test channels[1].name == "conda-forge"

    # Test global channel mapping
    channels = [
        CondaPkg.ChannelSpec("conda-forge"),
        CondaPkg.ChannelSpec("old-channel"),
        CondaPkg.ChannelSpec("other-channel"),
    ]
    mapping = Dict("old-channel" => "new-channel", "other-channel" => "mapped-channel")
    CondaPkg._resolve_map_channels!(channels, packages, mapping)
    @test [c.name for c in channels] == ["conda-forge", "new-channel", "mapped-channel"]

    # Test package-specific channel mapping
    channels = [CondaPkg.ChannelSpec("conda-forge")]
    packages = Dict(
        "foo" => Dict(
            "test1.toml" => CondaPkg.PkgSpec("foo", channel = "old-channel"),
            "test2.toml" => CondaPkg.PkgSpec("foo", channel = "other-channel"),
        ),
        "bar" =>
            Dict("test.toml" => CondaPkg.PkgSpec("bar", channel = "unmapped-channel")),
    )
    mapping = Dict("old-channel" => "new-channel", "other-channel" => "mapped-channel")
    CondaPkg._resolve_map_channels!(channels, packages, mapping)
    @test packages["foo"]["test1.toml"].channel == "new-channel"
    @test packages["foo"]["test2.toml"].channel == "mapped-channel"
    @test packages["bar"]["test.toml"].channel == "unmapped-channel"

    # Test both global and package-specific mapping together
    channels = [CondaPkg.ChannelSpec("conda-forge"), CondaPkg.ChannelSpec("old-channel")]
    packages =
        Dict("foo" => Dict("test.toml" => CondaPkg.PkgSpec("foo", channel = "old-channel")))
    mapping = Dict("old-channel" => "new-channel")
    CondaPkg._resolve_map_channels!(channels, packages, mapping)
    @test [c.name for c in channels] == ["conda-forge", "new-channel"]
    @test packages["foo"]["test.toml"].channel == "new-channel"

    # Test that other package properties are preserved
    channels = [CondaPkg.ChannelSpec("old-channel")]
    packages = Dict(
        "foo" => Dict(
            "test.toml" => CondaPkg.PkgSpec(
                "foo",
                version = "1.2.3",
                channel = "old-channel",
                build = "special",
            ),
        ),
    )
    mapping = Dict("old-channel" => "new-channel")
    CondaPkg._resolve_map_channels!(channels, packages, mapping)
    @test packages["foo"]["test.toml"].name == "foo"
    @test packages["foo"]["test.toml"].version == "1.2.3"
    @test packages["foo"]["test.toml"].channel == "new-channel"
    @test packages["foo"]["test.toml"].build == "special"
end

# Only run the gc tests on CI (because it's annoying to do it locally)
const testgc = get(ENV, "CI", "") == "true"

status() = sprint(io -> CondaPkg.status(io = io))

const backend = get(ENV, "JULIA_CONDAPKG_BACKEND", "Pixi")

const isnull = backend == "Null"
const ispixi = backend == "SystemPixi" || backend == "Pixi"

# reset the package state (so tests are independent of the order they are run)
rm(CondaPkg.cur_deps_file(), force = true)
CondaPkg.STATE.backend = :NotSet
CondaPkg.STATE.condaexe = ""
CondaPkg.STATE.pixiexe = ""
CondaPkg.STATE.resolved = false
CondaPkg.STATE.load_path = String[]
CondaPkg.STATE.meta_dir = ""
CondaPkg.STATE.frozen = false
CondaPkg.STATE.conda_env = ""
CondaPkg.STATE.shared = false
CondaPkg.STATE.testing = true
CondaPkg.STATE.test_preferences = Dict{String,Any}("backend" => backend)

# link the test folder into the test environment, e.g. for accessing test data
let test_dir = joinpath(dirname(CondaPkg.cur_deps_file()), "test")
    if !ispath(test_dir)
        symlink(joinpath(dirname(dirname(pathof(CondaPkg))), "test"), test_dir)
    end
end

ENV["JULIA_DEBUG"] = "CondaPkg"

"""
This file defines the types `PkgSpec`, `ChannelSpec` and `PipPkgSpec`, plus related
validation and normalisation functions.
"""

is_valid_string(name; allow_regex = false, allow_glob = false) =
    ('\'' ∉ name) &&
    ('"' ∉ name) &&
    (allow_regex || !(startswith(name, "^") && endswith(name, "\$"))) &&
    (allow_glob || '*' ∉ name)

struct PkgSpec
    name::String
    version::String
    channel::String
    build::String
    function PkgSpec(name; version = "", channel = "", build = "")
        name = validate_pkg(name)
        version = validate_version(version)
        channel = validate_channel(channel, allow_empty = true)
        build = validate_build(build)
        new(name, version, channel, build)
    end
end

# return a modified version of the given spec
function PkgSpec(
    old::PkgSpec;
    name = old.name,
    version = old.version,
    channel = old.channel,
    build = old.build,
)
    return PkgSpec(name; version, channel, build)
end

Base.:(==)(x::PkgSpec, y::PkgSpec) =
    (x.name == y.name) &&
    (x.version == y.version) &&
    (x.channel == y.channel) &&
    (x.build == y.build)
Base.hash(x::PkgSpec, h::UInt) =
    hash(x.build, hash(x.channel, hash(x.version, hash(x.name, h))))

is_valid_pkg(name) = occursin(r"^\s*[-_.a-zA-Z0-9]+\s*$", name) && is_valid_string(name)

normalise_pkg(name) = lowercase(strip(name))

validate_pkg(name) =
    if is_valid_pkg(name)
        normalise_pkg(name)
    else
        error("invalid package: $(repr(name))")
    end

is_valid_version(ver) =
    occursin(r"^\s*($|[!<>=0-9])", ver) && is_valid_string(ver; allow_glob = true)

normalise_version(ver) = strip(ver)

validate_version(ver) =
    if is_valid_version(ver)
        normalise_version(ver)
    else
        error("invalid version: $(repr(ver))")
    end

is_valid_build(build) = !occursin(''', build)

normalise_build(build) = strip(build)

validate_build(build) =
    if is_valid_build(build)
        return normalise_build(build)
    else
        error("invalid build: $(repr(build))")
    end

function specstr(x::PkgSpec)
    parts = String[]
    # always include the version, working around a bug in micromamba that the build is
    # ignored if the version is not set at all
    push!(parts, "version='$(x.version == "" ? "*" : x.version)'")
    x.channel == "" || push!(parts, "channel='$(x.channel)'")
    x.build == "" || push!(parts, "build='$(x.build)'")
    suffix = isempty(parts) ? "" : string("[", join(parts, ","), "]")
    string(x.name, suffix)
end

function pixispec(x::PkgSpec)
    spec = Dict{String,Any}()
    spec["version"] = x.version == "" ? "*" : x.version
    if x.build != ""
        spec["build"] = x.build
    end
    if x.channel != ""
        spec["channel"] = x.channel
    end
    if length(spec) == 1
        spec["version"]
    else
        spec
    end
end

struct ChannelSpec
    name::String
    function ChannelSpec(name)
        name = validate_channel(name)
        new(name)
    end
end

Base.:(==)(x::ChannelSpec, y::ChannelSpec) = (x.name == y.name)
Base.hash(x::ChannelSpec, h::UInt) = hash(x.name, h)

is_valid_channel(name; allow_empty = false) =
    (allow_empty || !isempty(strip(name))) && is_valid_string(name)

normalise_channel(name) = strip(name)

validate_channel(name; opts...) =
    if is_valid_channel(name; opts...)
        normalise_channel(name)
    else
        error("invalid channel: $(repr(name))")
    end

specstr(x::ChannelSpec) = x.name

struct PipPkgSpec
    name::String
    version::String
    binary::String
    extras::Vector{String}
    editable::Bool
    function PipPkgSpec(
        name;
        version = "",
        binary = "",
        extras = String[],
        editable = false,
    )
        name = validate_pip_pkg(name)
        version = validate_pip_version(version)
        binary = validate_pip_binary(binary)
        extras = validate_pip_extras(extras)
        validate_pip_editable(editable, version)
        new(name, version, binary, extras, editable)
    end
end

Base.:(==)(x::PipPkgSpec, y::PipPkgSpec) =
    (x.name == y.name) &&
    (x.version == y.version) &&
    (x.binary == y.binary) &&
    (x.extras == y.extras) &&
    (x.editable == y.editable)
Base.hash(x::PipPkgSpec, h::UInt) =
    hash(x.editable, hash(x.extras, hash(x.binary, hash(x.version, hash(x.name, h)))))

is_valid_pip_pkg(name) = occursin(r"^\s*[-_.A-Za-z0-9]+\s*$", name)

normalise_pip_pkg(name) = replace(lowercase(strip(name)), r"[-._]+" => "-")

validate_pip_pkg(name) =
    if is_valid_pip_pkg(name)
        normalise_pip_pkg(name)
    else
        error("invalid pip package: $(repr(name))")
    end

is_valid_pip_version(ver) = occursin(r"^\s*($|[~!<>=@])", ver) && !occursin(";", ver)

normalise_pip_version(ver) = strip(ver)

validate_pip_version(ver) =
    if is_valid_pip_version(ver)
        normalise_pip_version(ver)
    else
        error("invalid pip version: $(repr(ver))")
    end

is_valid_pip_binary(x) = x in ("only", "no", "")

normalise_pip_binary(x) = x

validate_pip_binary(x) =
    if is_valid_pip_binary(x)
        return normalise_pip_binary(x)
    else
        error("invalid pip binary: $(repr(x)) (expecting \"only\" or \"no\")")
    end

validate_pip_extras(x) = sort!(unique!(map(validate_pip_extra, convert(Vector{String}, x))))

is_valid_pip_extra(x) = is_valid_pip_pkg(x)

normalise_pip_extra(x) = normalise_pip_pkg(x)

validate_pip_extra(x) =
    if is_valid_pip_extra(x)
        return normalise_pip_extra(x)
    else
        error("invalid pip extra: $(repr(x))")
    end

function specstr(x::PipPkgSpec)
    parts = String[x.name]
    if !isempty(x.extras)
        push!(parts, " [", join(x.extras, ", "), "]")
    end
    if x.version != ""
        push!(parts, " ", x.version)
    end
    return join(parts)
end

function pixispec(x::PipPkgSpec)
    spec = Dict{String,Any}()
    if startswith(x.version, "@")
        url = strip(x.version[2:end])
        if startswith(url, "git+")
            url = url[5:end]
            if (m = match(r"^(.*?)@([^/@]*)$", url); m !== nothing)
                spec["git"] = m.captures[1]
                rev = m.captures[2]
                if (m = match(r"^([^#]*)#(.*)$", rev); m !== nothing)
                    # spec["tag"] = m.captures[1]
                    spec["rev"] = m.captures[2]
                else
                    spec["rev"] = rev
                end
            else
                spec["git"] = url
            end
        elseif startswith(url, "file:///")
            spec["path"] = pathfromurl(url)
        else
            spec["url"] = url
        end
    else
        spec["version"] = x.version == "" ? "*" : x.version
    end
    if x.editable
        spec["editable"] = true
    end
    if !isempty(x.extras)
        spec["extras"] = x.extras
    end
    if length(spec) == 1 && haskey(spec, "version")
        spec["version"]
    else
        spec
    end
end

validate_pip_editable(editable, version) =
    if editable && !startswith(version, "@")
        error(
            "invalid pip version for editable install: must start with `@` but version is $(version)",
        )
    end

"""All valid backends."""
const ALL_BACKENDS = (:MicroMamba, :Null, :System, :Current, :Pixi, :SystemPixi)

"""All backends that use a Conda/Mamba installer."""
const CONDA_BACKENDS = (:MicroMamba, :System, :Current)

"""All backends that use a Pixi installer."""
const PIXI_BACKENDS = (:Pixi, :SystemPixi)

function backend()
    if STATE.backend == :NotSet
        backend = getpref_backend()
        exe = getpref_exe()
        env = getpref_env()
        if backend == ""
            if exe == ""
                if env == "" && pixi_jll.is_available()
                    # cannot currently use pixi backend if env preference is set
                    # (see resolve())
                    backend = "Pixi"
                elseif MicroMamba.available()
                    backend = "MicroMamba"
                else
                    error(
                        "neither pixi nor micromamba is automatically available on your system",
                    )
                end
            else
                if occursin("pixi", lowercase(basename(exe)))
                    backend = "SystemPixi"
                else
                    backend = "System"
                end
            end
        end
        if backend == "MicroMamba"
            STATE.backend = :MicroMamba
        elseif backend == "Null"
            STATE.backend = :Null
        elseif backend == "Pixi"
            STATE.backend = :Pixi
        elseif backend == "System" || backend == "Current"
            ok = false
            for exe in (exe == "" ? ["micromamba", "mamba", "conda"] : [exe])
                exe2 = Sys.which(exe)
                if exe2 !== nothing
                    STATE.backend = Symbol(backend)
                    STATE.condaexe = exe2
                    ok = true
                    break
                end
            end
            if !ok
                if exe == ""
                    error("could not find a conda, mamba or micromamba executable")
                else
                    error("not an executable: $exe")
                end
            end
        elseif backend == "SystemPixi"
            exe2 = Sys.which(exe == "" ? "pixi" : exe)
            if exe2 === nothing
                if exe == ""
                    error("could not find a pixi executable")
                else
                    error("not an executable: $exe")
                end
            end
            STATE.backend = :SystemPixi
            STATE.pixiexe = exe2
        else
            error("invalid backend: $backend")
        end
    end
    @assert STATE.backend in ALL_BACKENDS
    STATE.backend
end

function conda_cmd(args = ``; io::IO = stderr)
    b = backend()
    if b == :MicroMamba
        MicroMamba.cmd(args, io = io)
    elseif b in CONDA_BACKENDS
        STATE.condaexe == "" && error("this is a bug")
        `$(STATE.condaexe) $args`
    else
        error("Cannot run conda when backend is $b.")
    end
end

default_pixi_cache_dir() = @get_scratch!("pixi_cache")

function pixi_cmd(args = ``; io::IO = stderr)
    b = backend()
    if b == :Pixi
        pixiexe = pixi_jll.pixi()
        if !haskey(ENV, "PIXI_CACHE_DIR") && !haskey(ENV, "RATTLER_CACHE_DIR")
            # if the cache dirs are not set, use a scratch dir
            pixi_cache_dir = default_pixi_cache_dir()
            pixiexe = addenv(
                pixiexe,
                "PIXI_CACHE_DIR" => pixi_cache_dir,
                "RATTLER_CACHE_DIR" => pixi_cache_dir,
            )
        end
        `$pixiexe $args`
    elseif b in PIXI_BACKENDS
        STATE.pixiexe == "" && error("this is a bug")
        `$(STATE.pixiexe) $args`
    else
        error("Cannot run pixi when backend is $b.")
    end
end

"""
Functions for interacting with the `CondaPkg.toml` file in the current project.

This is the main `Pkg`-like API, with functions like `add`, `rm`, `status`.
"""

function cur_deps_file()
    e = Base.load_path()[1]
    if !isdir(e)
        e = dirname(e)
        @assert isdir(e)
    end
    joinpath(e, "CondaPkg.toml")
end

function read_deps(; file = cur_deps_file())
    isfile(file) ? TOML.parsefile(file) : Dict{String,Any}()
end

function write_deps(toml; file = cur_deps_file())
    if isempty(toml)
        if isfile(file)
            Base.rm(file)
        end
    else
        open(file, "w") do io
            TOML.print(io, toml)
        end
    end
    return
end

function parse_deps(toml; main::Bool = true, dev::Bool = false)
    # packages
    packages = PkgSpec[]
    if main && haskey(toml, "deps")
        deps = _convert(Dict{String,Any}, toml["deps"])
        for (name, dep) in deps
            version = ""
            channel = ""
            build = ""
            if dep isa AbstractString
                version = _convert(String, dep)
            elseif dep isa AbstractDict
                for (k, v) in _convert(Dict{String,Any}, dep)
                    if k == "version"
                        version = _convert(String, v)
                    elseif k == "channel"
                        channel = _convert(String, v)
                    elseif k == "build"
                        build = _convert(String, v)
                    else
                        error("deps keys must be 'version', 'channel' or 'build', got '$k'")
                    end
                end
            else
                error("deps must be String or Dict, got $(typeof(dep))")
            end
            pkg = PkgSpec(name, version = version, channel = channel, build = build)
            push!(packages, pkg)
        end
    end

    # channels
    channels = ChannelSpec[]
    if main && haskey(toml, "channels")
        chan_names = _convert(Vector{String}, toml["channels"])
        for name in chan_names
            push!(channels, ChannelSpec(name))
        end
    end

    # pip packages
    pip_packages = PipPkgSpec[]
    if main && haskey(toml, "pip")
        pip = _convert(Dict{String,Any}, toml["pip"])
        if haskey(pip, "deps")
            pip_deps = _convert(Dict{String,Any}, pip["deps"])
            for (name, dep) in pip_deps
                version = ""
                binary = ""
                extras = String[]
                editable = false
                if dep isa AbstractString
                    version = _convert(String, dep)
                elseif dep isa AbstractDict
                    for (k, v) in _convert(Dict{String,Any}, dep)
                        if k == "version"
                            version = _convert(String, v)
                        elseif k == "binary"
                            binary = _convert(String, v)
                        elseif k == "extras"
                            extras = _convert(Vector{String}, v)
                        elseif k == "editable"
                            editable = _convert(Bool, v)
                        else
                            error(
                                "pip.deps keys must be 'version', 'extras', 'binary' or 'editable', got '$k'",
                            )
                        end
                    end
                else
                    error("pip.deps must be String or Dict, got $(typeof(dep))")
                end
                pkg = PipPkgSpec(
                    name,
                    version = version,
                    binary = binary,
                    extras = extras,
                    editable = editable,
                )
                push!(pip_packages, pkg)
            end
        end
    end

    # dev dependencies
    if dev && haskey(toml, "dev")
        devdeps = parse_deps(toml["dev"])
        append!(packages, devdeps.packages)
        append!(channels, devdeps.channels)
        append!(pip_packages, devdeps.pip_packages)
    end

    # done
    return (packages = packages, channels = channels, pip_packages = pip_packages)
end

function read_parsed_deps(file; main = true, dev = false)
    return parse_deps(read_deps(; file); main, dev)
end

function current_packages()
    b = backend()
    if b in CONDA_BACKENDS
        cmd = conda_cmd(`list -p $(envdir()) --json`)
        pkglist = JSON3.read(cmd)
    elseif b in PIXI_BACKENDS
        cmd =
            pixi_cmd(`list --manifest-path $(joinpath(STATE.meta_dir, "pixi.toml")) --json`)
        pkglist = JSON3.read(cmd)
        pkglist = [pkg for pkg in pkglist if pkg.kind == "conda"]
    end
    Dict(normalise_pkg(pkg.name) => pkg for pkg in pkglist)
end

function current_pip_packages()
    b = backend()
    if b in CONDA_BACKENDS
        pkglist = withenv() do
            cmd = `$(which("pip")) list --format=json`
            JSON3.read(cmd)
        end
    elseif b in PIXI_BACKENDS
        cmd =
            pixi_cmd(`list --manifest-path $(joinpath(STATE.meta_dir, "pixi.toml")) --json`)
        pkglist = JSON3.read(cmd)
        pkglist = [pkg for pkg in pkglist if pkg.kind == "pypi"]
    end
    Dict(normalise_pip_pkg(pkg.name) => pkg for pkg in pkglist)
end

"""
    status()

Show the status of the current environment.

This does not include dependencies from nested environments.
"""
function status(; io::IO = stderr)
    # collect information
    dfile = cur_deps_file()
    resolved = is_resolved()
    isnull = backend() == :Null
    dtoml = read_deps(; file = dfile)
    pkgs, channels, pippkgs = parse_deps(dtoml)
    dev_pkgs, dev_channels, dev_pippkgs = parse_deps(dtoml; main = false, dev = true)
    curpkgs =
        resolved && !isnull && (!isempty(pkgs) || !isempty(dev_pkgs)) ? current_packages() :
        nothing
    curpippkgs =
        resolved && !isnull && (!isempty(pippkgs) || !isempty(dev_pippkgs)) ?
        current_pip_packages() : nothing
    blank =
        isempty(pkgs) &&
        isempty(channels) &&
        isempty(pippkgs) &&
        isempty(dev_pkgs) &&
        isempty(dev_channels) &&
        isempty(dev_pippkgs)

    # print status
    printstyled(io, "CondaPkg Status", color = :light_green)
    printstyled(io, " ", dfile, bold = true)
    if blank
        print(io, " (empty)")
    end
    println(io)
    if !resolved
        printstyled(io, "Not Resolved", color = :yellow)
        println(io, " (resolve first for more information)")
    end
    if isnull
        printstyled(io, "Using the Null backend", color = :yellow)
        println(io, " (dependencies shown here are not being managed)")
    end
    if resolved
        printstyled(io, "Environment", bold = true, color = :cyan)
        println(io)
        println(io, "  ", STATE.conda_env)
    end
    function show_pkgs(pkgs, title)
        isempty(pkgs) && return
        printstyled(io, title, bold = true, color = :cyan)
        println(io)
        sort!(pkgs, by = x -> x.name)
        for pkg in pkgs
            print(io, "  ", pkg.name)
            if curpkgs !== nothing
                curpkg = get(curpkgs, pkg.name, nothing)
                if curpkg === nothing
                    printstyled(io, " uninstalled", color = :red)
                else
                    print(io, " v", curpkg.version)
                end
            end
            specparts = String[]
            pkg.version == "" || push!(specparts, pkg.version)
            pkg.channel == "" || push!(specparts, "channel=$(pkg.channel)")
            pkg.build == "" || push!(specparts, "build=$(pkg.build)")
            isempty(specparts) ||
                printstyled(io, " (", join(specparts, ", "), ")", color = :light_black)
            println(io)
        end
    end
    show_pkgs(pkgs, "Packages")
    show_pkgs(dev_pkgs, "Dev Packages")
    function show_channels(channels, title)
        isempty(channels) && return
        printstyled(io, title, bold = true, color = :cyan)
        println(io)
        sort!(channels, by = x -> x.name)
        for chan in channels
            println(io, "  ", chan.name)
        end
    end
    show_channels(channels, "Channels")
    show_channels(channels, "Dev Channels")
    function show_pippkgs(pippkgs, title)
        isempty(pippkgs) && return
        printstyled(io, title, bold = true, color = :cyan)
        println(io)
        sort!(pippkgs, by = x -> x.name)
        for pkg in pippkgs
            print(io, "  ", pkg.name)
            if curpippkgs !== nothing
                curpkg = get(curpippkgs, pkg.name, nothing)
                if curpkg === nothing
                    printstyled(io, " uninstalled", color = :red)
                else
                    print(io, " v", curpkg.version)
                end
            end
            specparts = String[]
            pkg.version == "" || push!(specparts, pkg.version)
            pkg.binary == "" || push!(specparts, "$(pkg.binary)-binary")
            if !isempty(pkg.extras)
                push!(specparts, "[$(join(pkg.extras, ", "))]")
            end
            if pkg.editable
                push!(specparts, "editable")
            end
            isempty(specparts) ||
                printstyled(io, " (", join(specparts, ", "), ")", color = :light_black)
            println(io)
        end
    end
    show_pippkgs(pippkgs, "Pip Packages")
    show_pippkgs(dev_pippkgs, "Dev Pip Packages")
end

# Do nothing for existing specs
_to_spec(s::Union{PkgSpec,PipPkgSpec,ChannelSpec}; channel = "") = s
# Convert strings to PkgSpec
_to_spec(s::AbstractString; channel = "") = PkgSpec(s; channel)

function _add_or_rm(
    op!::Function,
    pkgs::AbstractVector;
    channel = "",
    resolve = true,
    file = cur_deps_file(),
    io::IO = stderr,
    dev::Bool = false,
    kw...,
)
    old_content = (resolve && isfile(file)) ? read(file) : nothing
    toml = read_deps(; file)

    for pkg in pkgs
        spec = _to_spec(pkg; channel)
        if dev
            devtoml = get!(Dict{String,Any}, toml, "dev")
            op!(devtoml, spec)
            isempty(devtoml) && delete!(toml, "dev")
        else
            op!(toml, spec)
        end
    end
    write_deps(toml; file)
    STATE.resolved = false
    if resolve
        try
            CondaPkg.resolve(; io = io, kw...)
        catch
            _log(io, "Resolve failed, reverting $file")
            if old_content === nothing
                Base.rm(file)
            else
                write(file, old_content)
            end
            rethrow()
        end
    end
    return
end

function add(
    pkgs::AbstractVector;
    channel = "",
    resolve = true,
    file = cur_deps_file(),
    io::IO = stderr,
    kw...,
)
    _add_or_rm(add!, pkgs; channel, resolve, file, io, kw...)
end

add(pkg::Union{PkgSpec,PipPkgSpec,ChannelSpec}; kw...) = add([pkg]; kw...)

function rm(
    pkgs::AbstractVector;
    resolve = true,
    file = cur_deps_file(),
    io::IO = stderr,
    kw...,
)
    _add_or_rm(rm!, pkgs; channel = "", resolve, file, io, kw...)
end

rm(pkg::Union{PkgSpec,PipPkgSpec,ChannelSpec}; kw...) = rm([pkg]; kw...)

function add!(toml, pkg::PkgSpec)
    deps = get!(Dict{String,Any}, toml, "deps")
    filter!(kv -> normalise_pkg(kv[1]) != pkg.name, deps)
    dep = Dict{String,Any}()
    if pkg.version != ""
        dep["version"] = pkg.version
    end
    if pkg.channel != ""
        dep["channel"] = pkg.channel
    end
    if pkg.build != ""
        dep["build"] = pkg.build
    end
    if issubset(keys(dep), ["version"])
        deps[pkg.name] = pkg.version
    else
        deps[pkg.name] = dep
    end
end

function add!(toml, channel::ChannelSpec)
    channels = get!(Vector{Any}, toml, "channels")
    push!(channels, channel.name)
end

function add!(toml, pkg::PipPkgSpec)
    pip = get!(Dict{String,Any}, toml, "pip")
    deps = get!(Dict{String,Any}, pip, "deps")
    filter!(kv -> normalise_pip_pkg(kv[1]) != pkg.name, deps)
    dep = Dict{String,Any}()
    if pkg.version != ""
        dep["version"] = pkg.version
    end
    if pkg.binary != ""
        dep["binary"] = pkg.binary
    end
    if !isempty(pkg.extras)
        dep["extras"] = pkg.extras
    end
    if pkg.editable
        dep["editable"] = pkg.editable
    end
    if issubset(keys(dep), ["version"])
        deps[pkg.name] = pkg.version
    else
        deps[pkg.name] = dep
    end
end

function rm!(toml, pkg::PkgSpec)
    deps = get!(Dict{String,Any}, toml, "deps")
    n = length(deps)
    filter!(kv -> normalise_pkg(kv[1]) != pkg.name, deps)
    length(deps) < n || error("package not found: $(pkg.name)")
    isempty(deps) && delete!(toml, "deps")
end

function rm!(toml, channel::ChannelSpec)
    channels = get!(Vector{Any}, toml, "channels")
    n = length(channels)
    filter!(c -> normalise_channel(c) != channel.name, channels)
    length(channels) < n || error("channel not found: $(channel.name)")
    isempty(channels) && delete!(toml, "channels")
end

function rm!(toml, pkg::PipPkgSpec)
    pip = get!(Dict{String,Any}, toml, "pip")
    deps = get!(Dict{String,Any}, pip, "deps")
    n = length(deps)
    filter!(kv -> normalise_pip_pkg(kv[1]) != pkg.name, deps)
    length(deps) < n || error("pip package not found: $(pkg.name)")
    isempty(deps) && delete!(pip, "deps")
    isempty(pip) && delete!(toml, "pip")
end

"""
    add(pkg; version="", channel="", build="", resolve=true, dev=false)
    add([pkg1, pkg2, ...]; channel="", resolve=true, dev=false)

Adds a dependency to the current environment.
"""
add(pkg::AbstractString; version = "", channel = "", build = "", kw...) =
    add(PkgSpec(pkg, version = version, channel = channel, build = build); kw...)

"""
    rm(pkg; resolve=true, dev=false)
    rm([pkg1, pkg2, ...]; resolve=true, dev=false)

Removes a dependency from the current environment.
"""
rm(pkg::AbstractString; kw...) = rm(PkgSpec(pkg); kw...)

"""
    add_channel(channel; resolve=true, dev=false)

Adds a channel to the current environment.
"""
add_channel(channel::AbstractString; kw...) = add(ChannelSpec(channel); kw...)

"""
    rm_channel(channel; resolve=true, dev=false)

Removes a channel from the current environment.
"""
rm_channel(channel::AbstractString; kw...) = rm(ChannelSpec(channel); kw...)

"""
    add_pip(pkg; version="", binary="", extras=[], resolve=true, editable=false, dev=false)

Adds a pip dependency to the current environment.

!!! warning

    Use conda dependencies instead if at all possible. Pip does not handle version
    conflicts gracefully, so it is possible to get incompatible versions.
"""
add_pip(
    pkg::AbstractString;
    version = "",
    binary = "",
    extras = String[],
    editable = false,
    kw...,
) = add(
    PipPkgSpec(
        pkg,
        version = version,
        binary = binary,
        extras = extras,
        editable = editable,
    );
    kw...,
)

"""
    rm_pip(pkg; resolve=true, dev=false)

Removes a pip dependency from the current environment.
"""
rm_pip(pkg::AbstractString; kw...) = rm(PipPkgSpec(pkg); kw...)

"""
This file defines functions for interacting with the environment, such as `withenv()` and
`which()`. They all automatically resolve first.
"""

"""
    activate!(env)

"Activate" the Conda environment by modifying the given dict of environment variables.
"""
function activate!(e)
    backend() in (:Null, :Current) && return e
    old_path = get(e, "PATH", "")
    d = envdir()
    path_sep = Sys.iswindows() ? ';' : ':'
    new_path = join(bindirs(), path_sep)
    if backend() == :MicroMamba
        e["MAMBA_ROOT_PREFIX"] = MicroMamba.root_dir()
        new_path = "$(new_path)$(path_sep)$(dirname(MicroMamba.executable())))"
    end
    if old_path != ""
        new_path = "$(new_path)$(path_sep)$(old_path)"
    end
    e["PATH"] = new_path
    e["CONDA_PREFIX"] = d
    e["CONDA_DEFAULT_ENV"] = d
    e["CONDA_SHLVL"] = "1"
    e["CONDA_PROMPT_MODIFIER"] = "($d) "
    e
end

"""
    withenv(f::Function)

Call `f()` while the Conda environment is active.
"""
function withenv(f::Function)
    old_env = copy(ENV)
    # shell("activate")
    activate!(ENV)
    frozen = STATE.frozen
    STATE.frozen = true
    try
        return f()
    finally
        STATE.frozen = frozen
        # copy!(ENV, old_env) does not work (empty!(ENV) not implemented)
        for k in collect(keys(ENV))
            if !haskey(old_env, k)
                delete!(ENV, k)
            end
        end
        for (k, v) in old_env
            ENV[k] = v
        end
    end
end

"""
    envdir(...)

The root directory of the Conda environment.

Any additional arguments are joined to the path.

Throws an error if backend is Null.
"""
function envdir(args...)
    backend() == :Null && throw(ErrorException("Can not get envdir when backend is Null."))
    resolve()
    normpath(STATE.conda_env, args...)
end

"""
    bindirs()

The directories containing binaries in the Conda environment.
"""
function bindirs()
    e = envdir()
    if Sys.iswindows()
        (
            "$e",
            "$e\\Library\\mingw-w64\\bin",
            "$e\\Library\\usr\\bin",
            "$e\\Library\\bin",
            "$e\\Scripts",
            "$e\\bin",
        )
    else
        ("$e/bin", "$e/condabin")
    end
end

"""
    which(progname)

Find the binary called `progname` in the Conda environment.
"""
function which(progname)
    backend() in (:Null, :Current) && return Sys.which(progname)
    # Set the PATH to dirs in the environment, then use Sys.which().
    old_path = get(ENV, "PATH", nothing)
    ENV["PATH"] = join(bindirs(), Sys.iswindows() ? ';' : ':')
    try
        return Sys.which(progname)
    finally
        if old_path === nothing
            delete!(ENV, "PATH")
        else
            ENV["PATH"] = old_path
        end
    end
end

"""
    gc()

Remove unused packages and caches.
"""
function gc(; io::IO = stderr)
    b = backend()
    if b in CONDA_BACKENDS
        resolve()
        cmd = conda_cmd(`clean -y --all`, io = io)
        _run(io, cmd, "Removing unused caches")
    else
        _log(io, "GC does nothing with the $b backend.")
    end
    return
end

# The functions in CondaPkg.PkgREPL are not API
# but calling them is the closest thing to calling
# the Pkg REPL.

@testitem "add/rm package" begin
    include("setup.jl")
    CondaPkg.PkgREPL.add(["six==1.16.0"])
    @test occursin("six", status())
    @test occursin("(==1.16.0)", status())
    CondaPkg.PkgREPL.rm(["six"])
    @test !occursin("six", status())
end

@testitem "add/rm channel" begin
    include("setup.jl")
    CondaPkg.PkgREPL.channel_add(["numba"])
    @test occursin("numba", status())
    CondaPkg.PkgREPL.channel_rm(["numba"])
    @test !occursin("numba", status())
end

@testitem "add/rm pip package" begin
    include("setup.jl")
    CondaPkg.PkgREPL.pip_add(["six==1.16.0", "pydantic[email]==2.9.2"])
    @test occursin("six", status())
    @test occursin("(==1.16.0)", status())
    @test occursin("pydantic", status())
    @test occursin("(==2.9.2, [email])", status())
    CondaPkg.PkgREPL.pip_rm(["six", "pydantic"])
    @test !occursin("six", status())
    @test !occursin("pydantic", status())
end

@testitem "status" begin
    include("setup.jl")
    # TODO: capture the output and check it equals status()
    CondaPkg.PkgREPL.status()
end

@testitem "resolve" begin
    include("setup.jl")
    CondaPkg.PkgREPL.resolve()
    @test CondaPkg.is_resolved()
end

@testitem "update" begin
    include("setup.jl")
    CondaPkg.PkgREPL.update()
    @test CondaPkg.is_resolved()
end

@testitem "gc" begin
    include("setup.jl")
    testgc && CondaPkg.PkgREPL.gc()
    @test true
end

@testitem "run" begin
    include("setup.jl")
    if !isnull
        CondaPkg.add("python", version = "==3.10.2")
        fn = tempname()
        # run python --version and check the output
        open(fn, "w") do io
            redirect_stdout(io) do
                CondaPkg.PkgREPL.run(["python", "--version"])
            end
        end
        @test contains(read(fn, String), "3.10.2")
        # run conda --help and check the output
        # tests that conda and mamba both run whatever CondaPkg runs
        open(fn, "w") do io
            redirect_stdout(io) do
                CondaPkg.PkgREPL.run([ispixi ? "pixi" : "conda", "--help"])
            end
        end
        @test contains(read(fn, String), "--help")
        @test contains(read(fn, String), "--version")
    end
end

"""
This file defines functions to interact with the `.CondaPkg/meta` file which records
information about the most recent resolve.
"""

# increment whenever the metadata format changes
const META_VERSION = 15

@kwdef mutable struct Meta
    timestamp::Float64
    conda_env::String
    load_path::Vector{String}
    extra_path::Vector{String}
    version::VersionNumber
    backend::Symbol
    packages::Vector{PkgSpec}
    channels::Vector{ChannelSpec}
    pip_packages::Vector{PipPkgSpec}
end

function read_meta(io::IO)
    # TODO: magic number?
    if read(io, Int) == META_VERSION
        Meta(
            timestamp = read_meta(io, Float64),
            conda_env = read_meta(io, String),
            load_path = read_meta(io, Vector{String}),
            extra_path = read_meta(io, Vector{String}),
            version = read_meta(io, VersionNumber),
            backend = read_meta(io, Symbol),
            packages = read_meta(io, Vector{PkgSpec}),
            channels = read_meta(io, Vector{ChannelSpec}),
            pip_packages = read_meta(io, Vector{PipPkgSpec}),
        )
    end
end
function read_meta(io::IO, ::Type{Float64})
    read(io, Float64)
end
function read_meta(io::IO, ::Type{String})
    len = read(io, Int)
    bytes = read(io, len)
    if length(bytes) < len
        error("unexpected end of meta file")
    end
    String(bytes)
end
function read_meta(io::IO, ::Type{Symbol})
    Symbol(read_meta(io, String))
end
function read_meta(io::IO, ::Type{Bool})
    read(io, Bool)
end
function read_meta(io::IO, ::Type{Vector{T}}) where {T}
    len = read(io, Int)
    ans = Vector{T}()
    for _ = 1:len
        item = read_meta(io, T)
        push!(ans, item)
    end
    ans
end
function read_meta(io::IO, ::Type{VersionNumber})
    VersionNumber(read_meta(io, String))
end
function read_meta(io::IO, ::Type{PkgSpec})
    name = read_meta(io, String)
    version = read_meta(io, String)
    channel = read_meta(io, String)
    build = read_meta(io, String)
    PkgSpec(name, version = version, channel = channel, build = build)
end
function read_meta(io::IO, ::Type{ChannelSpec})
    name = read_meta(io, String)
    ChannelSpec(name)
end
function read_meta(io::IO, ::Type{PipPkgSpec})
    name = read_meta(io, String)
    version = read_meta(io, String)
    binary = read_meta(io, String)
    extras = read_meta(io, Vector{String})
    editable = read_meta(io, Bool)
    PipPkgSpec(name, version = version, binary = binary, extras = extras, editable = editable)
end

function write_meta(io::IO, meta::Meta)
    write(io, META_VERSION)
    write_meta(io, meta.timestamp)
    write_meta(io, meta.conda_env)
    write_meta(io, meta.load_path)
    write_meta(io, meta.extra_path)
    write_meta(io, meta.version)
    write_meta(io, meta.backend)
    write_meta(io, meta.packages)
    write_meta(io, meta.channels)
    write_meta(io, meta.pip_packages)
    return
end
function write_meta(io::IO, x::Float64)
    write(io, x)
end
function write_meta(io::IO, x::String)
    write(io, convert(Int, sizeof(x)))
    write(io, x)
end
function write_meta(io::IO, x::Symbol)
    write_meta(io, String(x))
end
function write_meta(io::IO, x::Bool)
    write(io, x)
end
function write_meta(io::IO, x::Vector)
    write(io, convert(Int, length(x)))
    for item in x
        write_meta(io, item)
    end
end
function write_meta(io::IO, x::VersionNumber)
    write_meta(io, string(x))
end
function write_meta(io::IO, x::PkgSpec)
    write_meta(io, x.name)
    write_meta(io, x.version)
    write_meta(io, x.channel)
    write_meta(io, x.build)
end
function write_meta(io::IO, x::ChannelSpec)
    write_meta(io, x.name)
end
function write_meta(io::IO, x::PipPkgSpec)
    write_meta(io, x.name)
    write_meta(io, x.version)
    write_meta(io, x.binary)
    write_meta(io, x.extras)
    write_meta(io, x.editable)
end

"""
This file defines `resolve()`, which ensures all dependencies are installed.
"""

function _resolve_top_env(load_path)
    top_env = ""
    for env in load_path
        proj = Base.env_project_file(env)
        is_condapkg = proj isa String && Base.project_file_name_uuid(proj, "").uuid == UUID
        depends_on_condapkg = Base.manifest_uuid_path(env, PKGID) !== nothing
        if is_condapkg || depends_on_condapkg
            top_env = proj isa String ? dirname(proj) : env
            break
        end
    end
    top_env == "" &&
        error("no environment in the LOAD_PATH ($load_path) depends on CondaPkg")
    top_env
end

function _resolve_env_is_clean(conda_env, meta)
    conda_env == meta.conda_env || return false
    stat(conda_env).mtime ≤ meta.timestamp || return false
    isdir(conda_env) && return true
    (isempty(meta.packages) && isempty(meta.pip_packages)) && return true
    false
end

function issamefile(file1, file2)
    ok1 = ispath(file1)
    ok2 = ispath(file2)
    if !ok1 && !ok2
        # both files don't exist, which is the same in a sense
        return true
    elseif ok1 && ok2
        # both files exist, so check if they are the same
        return samefile(file1, file2)
    else
        # if one exists and the other doesn't, they are not the same
        return false
    end
end

function dedupepaths(paths)
    deduped = String[]
    for path in paths
        if !any(dpath -> issamefile(path, dpath), deduped)
            push!(deduped, path)
        end
    end
    return deduped
end

function issameloadpath(load_path1, load_path2)
    if length(load_path1) != length(load_path2)
        return false
    end
    for (p1, p2) in zip(load_path1, load_path2)
        if !issamefile(p1, p2)
            return false
        end
    end
    return true
end

function _resolve_can_skip_1(conda_env, load_path, meta_file)
    if !isdir(conda_env)
        @debug "conda env does not exist" conda_env
        return false
    end
    if !isfile(meta_file)
        @debug "meta file does not exist" meta_file
        return false
    end
    meta = open(read_meta, meta_file)
    if meta === nothing
        @debug "meta file was not readable" meta_file
        return false
    end
    if meta.version != VERSION
        @debug "meta version has changed" meta.version VERSION
        return false
    end
    if !issameloadpath(meta.load_path, load_path)
        @debug "load path has changed" meta.load_path load_path
        return false
    end
    if !issamefile(meta.conda_env, conda_env)
        @debug "conda env has changed" meta.conda_env conda_env
        return false
    end
    if meta.backend != backend()
        @debug "backend has changed" meta.backend backend()
        return false
    end
    timestamp = max(meta.timestamp, stat(meta_file).mtime)
    for env in [meta.load_path; meta.extra_path]
        dir = isfile(env) ? dirname(env) : isdir(env) ? env : continue
        if isdir(dir)
            if stat(dir).mtime > timestamp
                @debug "environment has changed" env dir timestamp
                return false
            else
                fn = joinpath(dir, "CondaPkg.toml")
                if isfile(fn) && stat(fn).mtime > timestamp
                    @debug "environment has changed" env fn timestamp
                    return false
                end
            end
        end
    end
    return true
end

_convert(::Type{T}, @nospecialize(x)) where {T} = convert(T, x)::T

# For each (V, B) in this list, if Julia has libstdc++ loaded at version at least V, then
# B is a compatible bound for libstdcxx-ng.
# See https://gcc.gnu.org/onlinedocs/libstdc++/manual/abi.html.
# See https://github.com/gcc-mirror/gcc/blob/master/libstdc%2B%2B-v3/config/abi/pre/gnu.ver
# See https://gcc.gnu.org/develop.html#timeline.
# Last updated: 2025-05-11
const _compatible_libstdcxx_ng_versions = [
    (v"3.4.34", ">=3.4,<=15.1"),
    (v"3.4.33", ">=3.4,<15.0"),
    (v"3.4.32", ">=3.4,<14.0"),
    (v"3.4.31", ">=3.4,<13.2"),
    (v"3.4.30", ">=3.4,<13.0"),
    (v"3.4.29", ">=3.4,<12.0"),
    (v"3.4.28", ">=3.4,<11.0"),
    (v"3.4.27", ">=3.4,<9.3"),
    (v"3.4.26", ">=3.4,<9.2"),
    (v"3.4.25", ">=3.4,<9.0"),
    (v"3.4.24", ">=3.4,<8.0"),
    (v"3.4.23", ">=3.4,<7.2"),
    (v"3.4.22", ">=3.4,<7.0"),
    (v"3.4.21", ">=3.4,<6.0"),
    (v"3.4.20", ">=3.4,<5.0"),
    (v"3.4.19", ">=3.4,<4.9"),
]

const _libstdcxx_max_minor_version = let
    v = _compatible_libstdcxx_ng_versions[1][1]
    @assert v.major == 3
    @assert v.minor == 4
    Int(v.patch)
end

"""
    _compatible_libstdcxx_ng_version()

Version of libstdcxx-ng compatible with the libstdc++ loaded into Julia.

Specifying the package "libstdcxx-ng" with version "<=julia" will replace the version with
this one. This should be used by anything which embeds Python into the Julia process - for
instance it is used by PythonCall.

Overridden by the `libstdcxx_ng_version` preference.
"""
_compatible_libstdcxx_ng_version() =
    _compatible_libstdcxx_version(getpref_libstdcxx_ng_version())

"""
    _compatible_libstdcxx_version()

Version of libstdcxx compatible with the libstdc++ loaded into Julia.

Specifying the package "libstdcxx" with version "<=julia" will replace the version with
this one. This should be used by anything which embeds Python into the Julia process - for
instance it is used by PythonCall.

Overridden by the `libstdcxx_version` preference.
"""
_compatible_libstdcxx_version() = _compatible_libstdcxx_version(getpref_libstdcxx_version())

function _compatible_libstdcxx_version(bound)
    if bound == "ignore"
        return nothing
    elseif bound != ""
        return bound
    end
    if !Sys.islinux()
        return nothing
    end
    loaded_libstdcxx_version =
        Base.BinaryPlatforms.detect_libstdcxx_version(_libstdcxx_max_minor_version)
    if loaded_libstdcxx_version === nothing
        return nothing
    end
    @debug "found libstdcxx $(loaded_libstdcxx_version)"
    for (version, bound) in _compatible_libstdcxx_ng_versions
        if loaded_libstdcxx_version ≥ version
            return bound
        end
    end
    return nothing
end

"""
    _compatible_openssl_version()

Find the version that aligns with the installed `OpenSSL_jll` version, if any.

See https://www.openssl.org/policies/releasestrat.html.

Overridden by the `openssl_version` preference.
"""
function _compatible_openssl_version()
    bound = getpref_openssl_version()
    if bound == "ignore"
        return nothing
    elseif bound != ""
        return bound
    end
    deps = Pkg.dependencies()
    uuid = Base.UUID("458c3c95-2e84-50aa-8efc-19380b2a3a95")
    dep = get(deps, uuid, nothing)
    if (dep === nothing) || (dep.name != "OpenSSL_jll")
        return nothing
    end
    version = dep.version
    if version === nothing
        return nothing
    end
    @debug "found OpenSSL_jll $version"
    if version.major >= 3
        # from v3, minor releases are ABI-compatible
        return ">=$(version.major), <$(version.major).$(version.minor+1)"
    else
        # before this, only patch releases are ABI-compatible
        return ">=$(version.major).$(version.minor), <$(version.major).$(version.minor).$(version.patch+1)"
    end
end

# Helper function to extract channels in a given order from a dict
function _extract_ordered_channels(
    order::Vector{String},
    channel_dict::Dict{String,ChannelSpec},
)
    result = ChannelSpec[]
    for name in order
        channel = pop!(channel_dict, name, nothing)
        if channel !== nothing
            push!(result, channel)
        end
    end
    result
end

function _resolve_order_channels!(channels::Vector{ChannelSpec}, order::Vector{String})
    # Convert channels to dict for easier manipulation - this automatically deduplicates
    channel_dict = Dict(c.name => c for c in channels)
    empty!(channels)

    # Hard-coded extra orderings
    extra_before = ["conda-forge", "anaconda", "pkgs/main"]
    extra_after = String[]

    # Find where "..." appears in order, if at all
    ellipsis_idx = findfirst(==("..."), order)

    # Split order into before/after ellipsis
    before = ellipsis_idx === nothing ? order : order[1:ellipsis_idx-1]
    after = ellipsis_idx === nothing ? String[] : order[ellipsis_idx+1:end]

    # 1. User-specified before
    before_channels = _extract_ordered_channels(before, channel_dict)

    # 2. User-specified after
    after_channels = _extract_ordered_channels(after, channel_dict)

    # 3. Extra before
    extra_before_channels = _extract_ordered_channels(extra_before, channel_dict)

    # 4. Extra after
    extra_after_channels = _extract_ordered_channels(extra_after, channel_dict)

    # 5. Remaining channels (if ellipsis present or no explicit order given)
    # Sort by name to ensure consistent ordering
    remaining_channels = sort!(collect(ChannelSpec, values(channel_dict)), by = c -> c.name)

    # Concatenate all the channels
    append!(channels, before_channels)
    append!(channels, extra_before_channels)
    append!(channels, remaining_channels)
    append!(channels, extra_after_channels)
    append!(channels, after_channels)

    channels
end

function _resolve_map_channels!(
    channels::Vector{ChannelSpec},
    packages::Dict{String,Dict{String,PkgSpec}},
    mapping::Dict{String,String},
)
    isempty(mapping) && return channels

    # Apply mapping to each global channel in-place
    for i in eachindex(channels)
        if haskey(mapping, channels[i].name)
            channels[i] = ChannelSpec(mapping[channels[i].name])
        end
    end

    # Apply mapping to package-specific channels
    for (name, pkgs) in packages
        for (fn, spec) in pkgs
            if !isempty(spec.channel) && haskey(mapping, spec.channel)
                pkgs[fn] = PkgSpec(spec, channel = mapping[spec.channel])
            end
        end
    end
end

function _resolve_check_allowed_channels(
    io::IO,
    packages,
    channels,
    allowed_channels::Union{Nothing,Set{String}},
    dry_run::Bool = false,
)
    allowed_channels === nothing && return true

    # Check package-specific channels
    for (name, pkgs) in packages
        for (fn, spec) in pkgs
            if !isempty(spec.channel) && spec.channel ∉ allowed_channels
                if dry_run
                    return false
                end
                error(
                    "Package '$name' in $fn requires channel '$(spec.channel)' which is not in allowed channels list",
                )
            end
        end
    end

    # Check global channels
    disallowed = filter(c -> c.name ∉ allowed_channels, channels)
    if !isempty(disallowed)
        if dry_run
            return false
        end
        error(
            "The following channels are not in the allowed list: $(join(map(c->c.name, disallowed), ", "))",
        )
    end

    return true
end

function _resolve_find_dependencies(io, load_path)
    packages = Dict{String,Dict{String,PkgSpec}}() # name -> depsfile -> spec
    channels = ChannelSpec[]
    pip_packages = Dict{String,Dict{String,PipPkgSpec}}() # name -> depsfile -> spec
    extra_path = String[]
    parsed = Set{String}()
    dev_parsed = Set{String}()
    orig_project = Pkg.project().path
    function process_file(fn; env = nothing, dev = false)
        isfile(fn) || return
        if dev
            fn in dev_parsed && return
        else
            fn in parsed && return
        end
        push!(parsed, fn)
        dev && push!(dev_parsed, fn)
        if env !== nothing && env ∉ load_path && env ∉ extra_path
            push!(extra_path, env)
        end
        _log(io, "Found $(dev ? "dev " : "")dependencies: $fn")
        pkgs, chans, pippkgs = read_parsed_deps(fn; dev)
        for pkg in pkgs
            if pkg.name == "libstdcxx-ng" && pkg.version == "<=julia"
                version = _compatible_libstdcxx_ng_version()
                version === nothing && continue
                pkg = PkgSpec(pkg; version)
            end
            if pkg.name == "libstdcxx" && pkg.version == "<=julia"
                version = _compatible_libstdcxx_version()
                version === nothing && continue
                pkg = PkgSpec(pkg; version)
            end
            if pkg.name == "openssl" && pkg.version == "<=julia"
                version = _compatible_openssl_version()
                version === nothing && continue
                pkg = PkgSpec(pkg; version)
            end
            get!(Dict{String,PkgSpec}, packages, pkg.name)[fn] = pkg
        end
        if isempty(chans)
            push!(channels, ChannelSpec("conda-forge"))
        else
            append!(channels, chans)
        end
        for pkg in pippkgs
            get!(Dict{String,PipPkgSpec}, pip_packages, pkg.name)[fn] = pkg
        end
    end
    function process_env(env; dev = false)
        dir = isfile(env) ? dirname(env) : isdir(env) ? env : return
        process_file(joinpath(dir, "CondaPkg.toml"); env, dev)
    end
    function process_proj(proj)
        process_env(proj.path; dev = proj.ispackage)
    end
    function process_dep(dep)
        process_env(dep.source, dev = dep.is_tracking_path)
    end
    try
        for proj in dedupepaths(load_path)
            Pkg.activate(proj; io = devnull)
            process_proj(Pkg.project())
            foreach(process_dep, values(Pkg.dependencies()))
        end
    finally
        Pkg.activate(orig_project; io = devnull)
    end
    if isempty(channels)
        push!(channels, ChannelSpec("conda-forge"))
    end
    (packages, channels, pip_packages, extra_path)
end

function _resolve_merge_packages(packages, channels)
    specs = PkgSpec[]
    for (name, pkgs) in packages
        @assert length(pkgs) > 0
        # special case: name=python, channel=**cpython**
        if name == "python" && any(pkg.build == "**cpython**" for pkg in values(pkgs))
            candidate_channels = String[]
            append!(candidate_channels, (pkg.channel for pkg in values(pkgs)))
            append!(candidate_channels, (c.name for c in channels))
            filter!(c -> c in ("conda-forge", "anaconda", "pkgs/main"), candidate_channels)
            if isempty(candidate_channels)
                error(
                    "can currently only install cpython from conda-forge, anaconda or pkgs/main channel",
                )
            end
            channel = first(candidate_channels)
            for (fn, pkg) in collect(pkgs)
                if pkg.build == "**cpython**"
                    if pkg.channel == ""
                        pkg = PkgSpec(pkg, channel = channel)
                    end
                    if pkg.channel == "conda-forge"
                        build = "*cp*"  # "cpython" or "cp313"
                    elseif pkg.channel in ("anaconda", "pkgs/main")
                        build = ""
                    else
                        error(
                            "can currently only install cpython from conda-forge, anaconda or pkgs/main channel",
                        )
                    end
                    pkg = PkgSpec(pkg, build = build)
                    pkgs[fn] = pkg
                end
            end
        end
        # now merge packages with the same name
        version = ""
        channel = ""
        build = ""
        for (fn, pkg) in pkgs
            @assert pkg.name == name
            if pkg.version != ""
                if version == ""
                    version = pkg.version
                else
                    version = _resolve_merge_versions(version, pkg.version)
                end
            end
            if pkg.channel != ""
                if channel == ""
                    channel = pkg.channel
                elseif channel != pkg.channel
                    error("multiple channels specified for package '$name'")
                end
            end
            if pkg.build != ""
                if build == ""
                    build = pkg.build
                elseif build != pkg.build
                    error("multiple builds specified for package '$name'")
                end
            end
        end
        push!(specs, PkgSpec(name, version = version, channel = channel, build = build))
    end
    sort!(specs, by = x -> x.name)
end

function _resolve_merge_versions(v1, v2)
    parts1 = split(v1, "|")
    parts2 = split(v2, "|")
    parts = ["$(strip(part1)), $(strip(part2))" for part1 in parts1 for part2 in parts2]
    join(parts, " | ")
end

function abspathurl(args...)
    path = abspath(args...)
    if Sys.iswindows()
        path = replace(path, '\\' => '/')
        @assert !startswith(path, "/") # TODO: handle \\machine\... paths
        path = "/$path"
    else
        @assert startswith(path, "/")
    end
    return "file://$path"
end

# Inverse of abspathurl: convert a file:// URL (as produced by abspathurl) back to a local path
function pathfromurl(url::AbstractString)
    startswith(url, "file://") || error("not a file:// url: $url")
    # strip the "file://" prefix
    path = url[8:end]
    if Sys.iswindows()
        # abspathurl on Windows prepends a leading "/" before "C:/...".
        startswith(path, "/") || error("not supported")
        path = path[2:end]
        path = replace(path, '/' => '\\')
    end
    return path
end

function _resolve_merge_pip_packages(packages)
    specs = PipPkgSpec[]
    for (name, pkgs) in packages
        @assert length(pkgs) > 0
        versions = String[]
        urls = String[]
        binary = ""
        extras = String[]
        editable = false
        for (fn, pkg) in pkgs
            @assert pkg.name == name
            if startswith(pkg.version, "@")
                url = strip(pkg.version[2:end])
                if startswith(url, ".")
                    url = abspathurl(dirname(fn), url)
                end
                push!(urls, url)
            elseif pkg.version != ""
                push!(versions, pkg.version)
            end
            if pkg.binary != ""
                if binary in ("", pkg.binary)
                    binary = pkg.binary
                else
                    error(
                        "$(binary)-binary and $(pkg.binary)-binary both specified for pip package '$name'",
                    )
                end
            end
            append!(extras, pkg.extras)
            editable |= pkg.editable
        end
        sort!(unique!(urls))
        sort!(unique!(versions))
        sort!(unique!(extras))
        if isempty(urls)
            version = join(versions, ",")
        elseif isempty(versions)
            length(urls) == 1 || error(
                "multiple direct references ('@ ...') given for pip package '$name': $urls (from $pkgs)",
            )
            version = "@ $(urls[1])"
        else
            error(
                "direct references ('@ ...') and version specifiers both given for pip package '$name'",
            )
        end
        push!(
            specs,
            PipPkgSpec(
                name,
                version = version,
                binary = binary,
                extras = extras,
                editable = editable,
            ),
        )
    end
    sort!(specs, by = x -> x.name)
end

function _resolve_diff(old_specs, new_specs)
    # group by package name
    old_dict = Dict{String,Set{PkgSpec}}()
    for spec in old_specs
        push!(get!(Set{PkgSpec}, old_dict, spec.name), spec)
    end
    new_dict = Dict{String,Set{PkgSpec}}()
    for spec in new_specs
        push!(get!(Set{PkgSpec}, new_dict, spec.name), spec)
    end
    # find changes
    removed = collect(String, setdiff(keys(old_dict), keys(new_dict)))
    added = collect(String, setdiff(keys(new_dict), keys(old_dict)))
    changed = String[
        k for k in intersect(keys(old_dict), keys(new_dict)) if old_dict[k] != new_dict[k]
    ]
    # don't remove pip, this avoids some flip-flopping when removing pip packages
    filter!(x -> x != "pip", removed)
    return (removed, changed, added)
end

function _resolve_pip_diff(old_specs, new_specs)
    # make dicts
    old_dict = Dict{String,PipPkgSpec}(spec.name => spec for spec in old_specs)
    new_dict = Dict{String,PipPkgSpec}(spec.name => spec for spec in new_specs)
    # find changes
    removed = collect(String, setdiff(keys(old_dict), keys(new_dict)))
    added = collect(String, setdiff(keys(new_dict), keys(old_dict)))
    changed = String[
        k for k in intersect(keys(old_dict), keys(new_dict)) if old_dict[k] != new_dict[k]
    ]
    return (removed, changed, added)
end

function _verbosity_flags(n = getpref_verbosity())
    n < 0 ? ["-" * "q"^(-n)] : n > 0 ? ["-" * "v"^n] : String[]
end

function _resolve_conda_remove_all(io, conda_env)
    vrb = _verbosity_flags()
    cmd = conda_cmd(`remove $vrb -y -p $conda_env --all`, io = io)
    flags = append!(["-y", "--all"], vrb)
    _run(io, cmd, "Removing environment", flags = flags)
    nothing
end

function _resolve_conda_install(io, conda_env, specs, channels; create = false)
    (length(specs) == 0 && !create) && return  # installing 0 packages is invalid
    args = String[]
    for spec in specs
        push!(args, specstr(spec))
    end
    for channel in channels
        push!(args, "-c", specstr(channel))
    end

    # Set channel priority
    priority = getpref_channel_priority()
    if priority == "disabled"
        pushfirst!(args, "--no-channel-priority")
    elseif priority == "strict"
        pushfirst!(args, "--strict-channel-priority")
    else
        @assert priority == "flexible"
        # flexible is the default, no flag needed
    end

    vrb = _verbosity_flags()
    cmd = conda_cmd(
        `$(create ? "create" : "install") $vrb -y -p $conda_env --override-channels $args`,
        io = io,
    )
    flags = append!(
        ["-y", "--override-channels", "--no-channel-priority", "--strict-channel-priority"],
        vrb,
    )
    _run(io, cmd, create ? "Creating environment" : "Installing packages", flags = flags)
    nothing
end

function _resolve_conda_remove(io, conda_env, pkgs)
    vrb = _verbosity_flags()
    cmd = conda_cmd(`remove $vrb -y -p $conda_env $pkgs`, io = io)
    flags = append!(["-y"], vrb)
    _run(io, cmd, "Removing packages", flags = flags)
    nothing
end

function _pip_cmd(backend::Symbol)
    if backend == :uv
        uv = which("uv")
        uv === nothing && error("uv not installed")
        return `$uv pip`
    else
        @assert backend == :pip
        pip = which("pip")
        pip === nothing && error("pip not installed")
        return `$pip`
    end
end

function _resolve_pip_install(io, pip_specs, load_path, backend)
    args = String[]
    for spec in pip_specs
        if spec.binary == "only"
            push!(args, "--only-binary", spec.name)
        elseif spec.binary == "no"
            push!(args, "--no-binary", spec.name)
        end
        if spec.editable
            # remove the @ from the beginning of the path.
            url = replace(spec.version, r"@\s*" => "")
            push!(args, "--editable", url)
        end
    end
    for spec in pip_specs
        if !spec.editable
            push!(args, specstr(spec))
        end
    end
    vrb = _verbosity_flags()
    flags = vrb
    old_load_path = STATE.load_path
    try
        STATE.resolved = true
        STATE.load_path = load_path
        withenv() do
            pip = _pip_cmd(backend)
            cmd = `$pip install $vrb $args`
            _run(io, cmd, "Installing Pip packages", flags = flags)
        end
    finally
        STATE.resolved = false
        STATE.load_path = old_load_path
    end
    nothing
end

function _resolve_pip_remove(io, pkgs, load_path, backend)
    vrb = _verbosity_flags()
    flags = append!(["-y"], vrb)
    old_load_path = STATE.load_path
    try
        STATE.resolved = true
        STATE.load_path = load_path
        withenv() do
            pip = _pip_cmd(backend)
            if backend == :uv
                cmd = `$pip uninstall $vrb $pkgs`
            else
                cmd = `$pip uninstall -y $vrb $pkgs`
            end
            _run(io, cmd, "Removing Pip packages", flags = flags)
        end
    finally
        STATE.resolved = false
        STATE.load_path = old_load_path
    end
    nothing
end

function _log(printfunc::Function, io::IO, args...; label = "CondaPkg", opts...)
    printstyled(io, lpad(label, 12), " ", color = :green, bold = true)
    printfunc(io, args...; opts...)
    println(io)
    flush(io)
end

function _log(io::IO, args...; opts...)
    _log(printstyled, io, args...; opts...)
end

function _cmdlines(cmd, flags)
    lines = String[]
    isarg = false
    for x in cmd.exec
        if isarg
            lines[end] *= " $x"
            isarg = false
        else
            push!(lines, x)
            isarg = length(lines) > 1 && startswith(x, "-") && x ∉ flags
        end
    end
    lines
end

function _logblock(io::IO, lines; kw...)
    lines = collect(String, lines)
    for (i, line) in enumerate(lines)
        pre = i == length(lines) ? "└ " : "│ "
        _log(io, label = "") do io
            print(io, pre)
            printstyled(io, line; kw...)
        end
    end
end

function _run(io::IO, cmd::Cmd, args...; flags = String[])
    _log(io, args...)
    if getpref_verbosity() ≥ 0
        lines = _cmdlines(cmd, flags)
        _logblock(io, lines, color = :light_black)
    end
    run(cmd)
end

function resolve(;
    force::Bool = false,
    io::IO = stderr,
    interactive::Bool = false,
    dry_run::Bool = false,
)
    # if frozen, do nothing
    STATE.frozen && return
    # if backend is Null, assume resolved
    back = backend()
    if back === :Null
        @debug "using the null backend"
        interactive && _log(io, "Using the Null backend, nothing to do")
        STATE.resolved = true
        return
    end
    # skip resolving if already resolved and LOAD_PATH unchanged
    # this is a very fast check which avoids touching the file system
    load_path = Base.load_path()
    if !force && STATE.resolved && STATE.load_path == load_path
        @debug "already resolved (fast path)"
        interactive && _log(io, "Dependencies already up to date (resolved)")
        return
    end
    STATE.resolved = false
    STATE.load_path = load_path
    # find the topmost env in the load_path which depends on CondaPkg
    top_env = _resolve_top_env(load_path)
    STATE.meta_dir = meta_dir = joinpath(top_env, ".CondaPkg")
    conda_env = getpref_env()
    if back === :Current
        conda_env = get(ENV, "CONDA_PREFIX", "")
        conda_env != "" || error(
            "CondaPkg is using the Current backend, but you are not in a Conda environment",
        )
        shared = true
    elseif conda_env == ""
        if back in CONDA_BACKENDS
            conda_env = joinpath(meta_dir, "env")
        elseif back in PIXI_BACKENDS
            conda_env = joinpath(meta_dir, ".pixi", "envs", "default")
        else
            error("this is a bug")
        end
        shared = false
    elseif !(back in CONDA_BACKENDS)
        error("cannot set env preference with $back backend")
    elseif startswith(conda_env, "@")
        conda_env_name = conda_env[2:end]
        conda_env_name == "" && error("shared env name cannot be empty")
        any(c -> c in ('\\', '/', '@', '#'), conda_env_name) &&
            error("shared env name cannot include special characters")
        conda_env = joinpath(Base.DEPOT_PATH[1], "conda_environments", conda_env_name)
        shared = true
    else
        isabspath(conda_env) || error("shared env must be an absolute path")
        occursin(".CondaPkg", conda_env) &&
            error("shared env must not be an existing .CondaPkg, select another directory")
        shared = true
    end
    STATE.conda_env = conda_env
    STATE.shared = shared
    meta_file = joinpath(meta_dir, "meta")
    lock_file = joinpath(meta_dir, "lock")
    # grap a file lock so only one process can resolve this environment at a time
    mkpath(meta_dir)
    lock = try
        Pidfile.mkpidlock(lock_file; wait = false)
    catch
        @info "CondaPkg: Waiting for lock to be freed. You may delete this file if no other process is resolving." lock_file
        Pidfile.mkpidlock(lock_file; wait = true)
    end
    try
        # skip resolving if nothing has changed since the metadata was updated
        if !force && _resolve_can_skip_1(conda_env, load_path, meta_file)
            @debug "already resolved"
            STATE.resolved = true
            interactive && _log(io, "Dependencies already up to date")
            return
        end
        # find all dependencies
        (packages, channels, pip_packages, extra_path) =
            _resolve_find_dependencies(io, load_path)

        # validate channels against allowed list
        if !_resolve_check_allowed_channels(
            io,
            packages,
            channels,
            getpref_allowed_channels(),
            dry_run,
        )
            dry_run && return
        end

        # order channels according to preferences
        _resolve_order_channels!(channels, getpref_channel_order())

        # apply channel mapping
        _resolve_map_channels!(channels, packages, getpref_channel_mapping())

        # install pip if there are pip packages to install
        pip_backend = getpref_pip_backend()
        if !isempty(pip_packages)
            if pip_backend == :pip
                if !haskey(packages, "pip")
                    if !any(c.name in ("conda-forge", "anaconda") for c in channels)
                        push!(channels, ChannelSpec("conda-forge"))
                    end
                end
                get!(Dict{String,PkgSpec}, packages, "pip")["<internal>"] =
                    PkgSpec("pip", version = ">=22.0.0")
            else
                @assert pip_backend == :uv
                if !haskey(packages, "uv")
                    if !any(c.name in ("conda-forge",) for c in channels)
                        push!(channels, ChannelSpec("conda-forge"))
                    end
                end
                get!(Dict{String,PkgSpec}, packages, "uv")["<internal>"] =
                    PkgSpec("uv", version = ">=0.4")
                if !haskey(packages, "python")
                    # uv will not detect the conda environment if python is not installed
                    get!(Dict{String,PkgSpec}, packages, "python")["<internal>"] =
                        PkgSpec("python")
                end
            end
        end
        # merge dependencies
        specs = _resolve_merge_packages(packages, channels)
        # merge pip dependencies
        pip_specs = _resolve_merge_pip_packages(pip_packages)
        # find what has changed
        meta = isfile(meta_file) ? open(read_meta, meta_file) : nothing
        if meta === nothing
            removed_pkgs = String[]
            changed_pkgs = String[]
            added_pkgs = unique!(String[x.name for x in specs])
            removed_pip_pkgs = String[]
            changed_pip_pkgs = String[]
            added_pip_pkgs = unique!(String[x.name for x in pip_specs])
        else
            removed_pkgs, changed_pkgs, added_pkgs = _resolve_diff(meta.packages, specs)
            removed_pip_pkgs, changed_pip_pkgs, added_pip_pkgs =
                _resolve_pip_diff(meta.pip_packages, pip_specs)
        end
        changes = sort([
            (i > 3 ? "$pkg (pip)" : pkg, mod1(i, 3)) for (i, pkgs) in enumerate([
                added_pkgs,
                changed_pkgs,
                removed_pkgs,
                added_pip_pkgs,
                changed_pip_pkgs,
                removed_pip_pkgs,
            ]) for pkg in pkgs
        ])
        dry_run |= getpref_offline()
        if !isempty(changes)
            _log(
                io,
                dry_run ? "Offline mode, these changes are not resolved" :
                "Resolving changes",
            )
            for (pkg, i) in changes
                char = i == 1 ? "+" : i == 2 ? "~" : "-"
                color = i == 1 ? :green : i == 2 ? :yellow : :red
                _log(io, char, " ", pkg, label = "", color = color)
            end
        end
        if back in CONDA_BACKENDS
            # install/uninstall packages
            if !force && meta !== nothing && _resolve_env_is_clean(conda_env, meta)
                # the state is sufficiently clean that we can modify the existing conda environment
                changed = false
                if !isempty(removed_pip_pkgs) && !shared
                    dry_run && return
                    changed = true
                    _resolve_pip_remove(io, removed_pip_pkgs, load_path, pip_backend)
                end
                if !isempty(removed_pkgs) && !shared
                    dry_run && return
                    changed = true
                    _resolve_conda_remove(io, conda_env, removed_pkgs)
                end
                if !isempty(specs) && (
                    !isempty(added_pkgs) ||
                    !isempty(changed_pkgs) ||
                    (meta.channels != channels) ||
                    changed
                )
                    dry_run && return
                    changed = true
                    _resolve_conda_install(io, conda_env, specs, channels)
                end
                if !isempty(pip_specs) &&
                   (!isempty(added_pip_pkgs) || !isempty(changed_pip_pkgs) || changed)
                    dry_run && return
                    changed = true
                    _resolve_pip_install(io, pip_specs, load_path, pip_backend)
                end
                changed || _log(io, "Dependencies already up to date")
            else
                # the state is too dirty, recreate the conda environment from scratch
                dry_run && return
                # remove environment
                mkpath(meta_dir)
                create = true
                if isdir(conda_env)
                    if shared
                        create = false
                    else
                        _resolve_conda_remove_all(io, conda_env)
                    end
                end
                # create conda environment
                _resolve_conda_install(io, conda_env, specs, channels; create = create)
                # install pip packages
                isempty(pip_specs) ||
                    _resolve_pip_install(io, pip_specs, load_path, pip_backend)
            end
        elseif back in PIXI_BACKENDS
            dry_run && return
            cd(meta_dir) do
                # remove existing files that might confuse pixi
                Base.rm(joinpath(meta_dir, "pixi.toml"), force = true)
                Base.rm(joinpath(meta_dir, "pyproject.toml"), force = true)
                force && Base.rm(joinpath(meta_dir, "pixi.lock"), force = true)
                # write .pixi/config.toml
                configtomlpath = joinpath(meta_dir, ".pixi", "config.toml")
                configtoml = Dict{String,Any}("detached-environments" => false)
                configtomlstr = sprint(TOML.print, configtoml)
                mkpath(dirname(configtomlpath))
                write(configtomlpath, configtomlstr)
                # initialise pixi
                vrb = getpref_verbosity()
                vrb_flags = _verbosity_flags(vrb)
                _run(
                    io,
                    pixi_cmd(`init $vrb_flags --format pixi $meta_dir`),
                    "Initialising pixi",
                    flags = vrb_flags,
                )
                # load pixi.toml
                pixitomlpath = joinpath(meta_dir, "pixi.toml")
                pixitoml = open(TOML.parse, pixitomlpath)
                # new pixi.toml
                channel_priority = getpref_channel_priority()
                if channel_priority == "flexible"
                    channel_priority = "strict"
                end
                # earlier versions of `pixi init` (pixi < v0.43.0) created
                # [project] instead of [workspace]
                pixiworkspace = if haskey(pixitoml, "project")
                    pixitoml["project"]
                else
                    pixitoml["workspace"]
                end
                pixitoml = Dict{String,Any}(
                    "project" => Dict{String,Any}(
                        "name" => ".CondaPkg",
                        "description" => "automatically generated by CondaPkg.jl",
                        "platforms" => pixiworkspace["platforms"],
                        "channels" => String[specstr(channel) for channel in channels],
                        "channel-priority" => channel_priority,
                    ),
                    "dependencies" =>
                        Dict{String,Any}(spec.name => pixispec(spec) for spec in specs),
                )
                if !isempty(pip_specs)
                    pixitoml["pypi-dependencies"] =
                        Dict{String,Any}(spec.name => pixispec(spec) for spec in pip_specs)
                end
                for spec in pip_specs
                    if spec.binary != ""
                        _log(
                            io,
                            "Warning: $b backend ignoring binary=$(spec.binary) for $(spec.name)",
                        )
                    end
                end
                pixitomlstr = sprint(TOML.print, pixitoml)
                write(pixitomlpath, pixitomlstr)
                _log(io, "Wrote $pixitomlpath")
                if vrb ≥ 0
                    _logblock(io, eachline(pixitomlpath), color = :light_black)
                end
                if force
                    _run(
                        io,
                        pixi_cmd(`update $vrb_flags --manifest-path $pixitomlpath`),
                        "Updating packages",
                        flags = vrb_flags,
                    )
                end
                _run(
                    io,
                    pixi_cmd(`install $vrb_flags --manifest-path $pixitomlpath`),
                    "Installing packages",
                    flags = vrb_flags,
                )
            end
        else
            error("this is a bug")
        end
        # save metadata
        meta = Meta(
            timestamp = time(),
            conda_env = conda_env,
            load_path = load_path,
            extra_path = extra_path,
            version = VERSION,
            backend = back,
            packages = specs,
            channels = channels,
            pip_packages = pip_specs,
        )
        open(io -> write_meta(io, meta), meta_file, "w")
        # all done
        STATE.resolved = true
        return
    finally
        close(lock)
    end
end

function is_resolved()
    resolve(io = devnull, dry_run = true)
    STATE.resolved
end

function update()
    resolve(force = true, interactive = true)
end

module PkgREPL

import ..CondaPkg
import Pkg
import Markdown

### parsing

function parse_pkg(x::String)
    m = match(
        r"""
^
(?:([^\s\:]+)::)?  # channel
([-_.A-Za-z0-9]+)  # name
(?:\@?([<>=!0-9][^\s\#]*))?  # version
(?:\#([^\s]+))?  # build
$
"""x,
        x,
    )
    m === nothing && error("invalid conda package: $x")
    channel = something(m.captures[1], "")
    name = m.captures[2]
    version = something(m.captures[3], "")
    build = something(m.captures[4], "")
    CondaPkg.PkgSpec(name, version = version, channel = channel, build = build)
end

function parse_pip_pkg(x::String; binary::String = "", editable = false)
    m = match(
        r"""
^
([-_.A-Za-z0-9]+)
(\[([^\]]*)\])?
([~!<>=@].*)?
$
"""x,
        x,
    )
    m === nothing && error("invalid pip package: $x")
    name = m.captures[1]
    extras = split(something(m.captures[3], ""), ",", keepempty = false)
    version = something(m.captures[4], "")
    CondaPkg.PipPkgSpec(
        name,
        version = version,
        binary = binary,
        extras = extras,
        editable = editable,
    )
end

function parse_channel(x::String)
    CondaPkg.ChannelSpec(x)
end

### options

const force_opt = Pkg.REPLMode.OptionDeclaration([
    :name => "force",
    :short_name => "f",
    :api => :force => true,
])

const binary_opt = Pkg.REPLMode.OptionDeclaration([
    :name => "binary",
    :takes_arg => true,
    :api => :binary => identity,
])

const editable_opt = Pkg.REPLMode.OptionDeclaration([
    :name => "editable",
    :short_name => "e",
    :takes_arg => false,
    :api => :editable => true,
])

const dev_opt = Pkg.REPLMode.OptionDeclaration([:name => "dev", :api => :dev => true])

### status

function status()
    CondaPkg.status()
end

const status_help = Markdown.parse("""
```
conda st|status
```

Display information about the Conda environment.
""")

const status_spec = Pkg.REPLMode.CommandSpec(
    name = "status",
    short_name = "st",
    api = status,
    help = status_help,
    description = "information about the Conda environment",
)

### resolve

function resolve(; force = false)
    CondaPkg.resolve(force = force, interactive = true)
end

const resolve_help = Markdown.parse("""
```
conda [-f|--force] resolve
```

Ensure all Conda dependencies are installed into the environment.
""")

const resolve_spec = Pkg.REPLMode.CommandSpec(
    name = "resolve",
    api = resolve,
    help = resolve_help,
    description = "ensure all Conda dependencies are installed",
    option_spec = [force_opt],
)

### update

function update()
    CondaPkg.update()
end

const update_help = Markdown.parse("""
```
conda update
```

Update Conda dependencies.
""")

const update_spec = Pkg.REPLMode.CommandSpec(
    name = "update",
    api = update,
    help = update_help,
    description = "update Conda dependencies",
)

### add

function add(args; dev = false)
    CondaPkg.add(parse_pkg.(args); dev)
end

const add_help = Markdown.parse("""
```
conda add [--dev] pkg ...
```

Add packages to the environment.

**Examples**

```
pkg> conda add python
pkg> conda add python>=3.5,<4       # version range
pkg> conda add python@3.9.*|3.10.*  # version pattern
pkg> conda add conda-forge::numpy   # channel
pkg> conda add tensorflow#cpu*      # build string pattern
```
""")

const add_spec = Pkg.REPLMode.CommandSpec(
    name = "add",
    api = add,
    should_splat = false,
    help = add_help,
    description = "add Conda packages",
    arg_count = 0 => Inf,
    option_spec = [dev_opt],
)

### channel_add

function channel_add(args; dev = false)
    CondaPkg.add(parse_channel.(args); dev)
end

const channel_add_help = Markdown.parse("""
```
conda channel_add [--dev] channel ...
```

Add channels to the environment.

**Examples**

```
pkg> conda channel_add conda-forge
```
""")

const channel_add_spec = Pkg.REPLMode.CommandSpec(
    name = "channel_add",
    api = channel_add,
    should_splat = false,
    help = channel_add_help,
    description = "add Conda channels",
    arg_count = 0 => Inf,
    option_spec = [dev_opt],
)

### pip_add

function pip_add(args; binary = "", editable = false, dev = false)
    CondaPkg.add([parse_pip_pkg(arg; binary, editable) for arg in args]; dev)
end

const pip_add_help = Markdown.parse("""
```
conda pip_add [--binary={only|no}] [--editable] [--dev] pkg ...
```

Add Pip packages to the environment.

**Examples**

```
pkg> conda pip_add build
pkg> conda pip_add build~=0.7                # version range
pkg> conda pip_add pydantic[email,timezone]  # extras
pkg> conda pip_add --binary=no nmslib        # always build from source
pkg> conda pip_add --editable nmslib@/path/to/package_source  # install locally
```
""")

const pip_add_spec = Pkg.REPLMode.CommandSpec(
    name = "pip_add",
    api = pip_add,
    should_splat = false,
    help = pip_add_help,
    description = "add Pip packages",
    arg_count = 0 => Inf,
    option_spec = [binary_opt, editable_opt, dev_opt],
)

### rm

function rm(args; dev = false)
    CondaPkg.rm(parse_pkg.(args); dev)
end

const rm_help = Markdown.parse("""
```
conda rm|remove [--dev] pkg ...
```

Remove packages from the environment.

**Examples**

```
pkg> conda rm python
```
""")

const rm_spec = Pkg.REPLMode.CommandSpec(
    name = "remove",
    short_name = "rm",
    api = rm,
    should_splat = false,
    help = rm_help,
    description = "remove Conda packages",
    arg_count = 0 => Inf,
    option_spec = [dev_opt],
)

### channel_rm

function channel_rm(args; dev = false)
    CondaPkg.rm(parse_channel.(args); dev)
end

const channel_rm_help = Markdown.parse("""
```
conda channel_rm|channel_remove [--dev] channel ...
```

Remove channels from the environment.

**Examples**

```
pkg> conda channel_rm conda-forge
```
""")

const channel_rm_spec = Pkg.REPLMode.CommandSpec(
    name = "channel_remove",
    short_name = "channel_rm",
    api = channel_rm,
    should_splat = false,
    help = channel_rm_help,
    description = "remove Conda channels",
    arg_count = 0 => Inf,
    option_spec = [dev_opt],
)

### pip_rm

function pip_rm(args; dev = false)
    CondaPkg.rm(parse_pip_pkg.(args); dev)
end

const pip_rm_help = Markdown.parse("""
```
conda pip_rm|pip_remove [--dev] pkg ...
```

Remove Pip packages from the environment.

**Examples**

```
pkg> conda pip_rm build
```
""")

const pip_rm_spec = Pkg.REPLMode.CommandSpec(
    name = "pip_remove",
    short_name = "pip_rm",
    api = pip_rm,
    should_splat = false,
    help = pip_rm_help,
    description = "remove Pip packages",
    arg_count = 0 => Inf,
    option_spec = [dev_opt],
)

### gc

function gc()
    CondaPkg.gc()
end

const gc_help = Markdown.parse("""
```
conda gc
```

Delete any files no longer used by Conda.
""")

const gc_spec = Pkg.REPLMode.CommandSpec(
    name = "gc",
    api = gc,
    help = gc_help,
    description = "delete files no longer used by Conda",
)

### run

function run(args)
    try
        CondaPkg.withenv() do
            b = CondaPkg.backend()
            if b in CondaPkg.CONDA_BACKENDS && args[1] == "conda"
                Base.run(CondaPkg.conda_cmd(args[2:end]))
            elseif b in CondaPkg.PIXI_BACKENDS && args[1] == "pixi"
                Base.run(CondaPkg.pixi_cmd(args[2:end]))
            else
                Base.run(Cmd(args))
            end
        end
    catch err
        Base.display_error(err)
    end
end

const run_help = Markdown.parse("""
```
conda run cmd ...
```

Run the given command in the Conda environment.

You can do `conda run conda ...` to run whichever conda (or mamba or micromamba) executable
that CondaPkg uses. Or in a pixi backend, do `conda run pixi ...` to run the pixi executable.
""")

const run_spec = Pkg.REPLMode.CommandSpec(
    name = "run",
    api = run,
    should_splat = false,
    help = run_help,
    arg_count = 1 => Inf,
    description = "run a command in the Conda environment",
)

### all specs

const SPECS = Dict(
    "st" => status_spec,
    "status" => status_spec,
    "resolve" => resolve_spec,
    "up" => update_spec,
    "update" => update_spec,
    "add" => add_spec,
    "remove" => rm_spec,
    "rm" => rm_spec,
    "channel_add" => channel_add_spec,
    "channel_remove" => channel_rm_spec,
    "channel_rm" => channel_rm_spec,
    "pip_add" => pip_add_spec,
    "pip_remove" => pip_rm_spec,
    "pip_rm" => pip_rm_spec,
    "gc" => gc_spec,
    "run" => run_spec,
)

function __init__()
    # add the commands to the repl
    Pkg.REPLMode.SPECS["conda"] = SPECS
    # update the help with the new commands
    copy!(Pkg.REPLMode.help.content, Pkg.REPLMode.gen_help().content)
end

end
